Imports CQG
Imports System.Runtime.InteropServices

Public Class frmAccountsAndPositions
   Inherits System.Windows.Forms.Form

   Private Const N_A As String = "N/A"
   Private Const LIST_ACC_COL_WIDTH As Integer = 35

   Private Const DATE_OF_LAST_STATEMENT As String = "Date Of Last Statement:"
   Private Const FCM_ACCOUNT_ID As String = "Fcm Account ID:"
   Private Const FCM_ID As String = "Fcm ID:"
   Private Const FCM_NAME As String = "Fcm Name:"
   Private Const GW_ACCOUNT_ID As String = "GW Account ID:"
   Private Const GW_ACCOUNT_NAME As String = "GW Account Name:"
   Private Const POSITION_SUBSCRIPTION_LEVEL As String = "Position Subcription Level:"
   Private Const REPORTING_CURRENCY As String = "Reporting Currency:"
   Private Const SERVER_TIMESTAMP As String = "Server Timestamp:"
   Private Const TIMESTAMP As String = "Timestamp:"
   Private Const ACCOUNT_BALANCE As String = "Account Balance:"
   Private Const INITIAL_MARGIN As String = "Initial Margin:"
   Private Const MAINTENANCE_MARGIN As String = "Maintenance Margin:"
   Private Const OPEN_TRADE_EQUITY As String = "Open Trade Equity:"
   Private Const UNREALIZED_PROFIT_LOSS_FOR_OPTIONS As String = "Unrealized Profit/Loss for Options:"
   Private Const COLLATERAL_ON_DEPOSIT As String = "Collateral on Deposit:"
   Private Const NET_LIQUIDITY_VALUE As String = "Net Liquidity Value:"
   Private Const MARKET_VALUE_OF_OPTIONS As String = "Market Value of Options:"
   Private Const CASH_EXCESS As String = "Cash Excess:"
   Private Const AVERAGE_PRICE As String = "Average Price:"
   Private Const MARKET_VALUE_OPTION As String = "Market Value Option:"
   Private Const PROFIT_LOSS As String = "Profit/Loss:"
   Private Const LONG_ As String = "Long:"
   Private Const SHORT_ As String = "Short:"
   Private Const OFFSET As String = "Offset:"
   Private Const CURRENCY As String = "Currency:"
   Private Const TOTAL_MARGIN As String = "Total Margin:"
   Private Const PURCHASING_POWER As String = "Total Purchasing Power:"
   Private Const MARGIN_DETAILING As String = "Margin Detailing Level:"



    Private WithEvents m_CEL As CQGCEL

    ''' Grids for dumping Properties/Summaries/Positions
    Private m_PropertiesGrid As CQGMiniGrid
    Private m_PositionsGrid As CQGMiniGrid
    Private m_SummariesGrid As CQGMiniGrid
    
    ''' HashTable which maps properties names with their rows in m_PropertiesGrid grid
    Private m_PropertyToRow As Hashtable
    ''' HashTable which maps items of summary with their rows in m_SummariesGrid grid
    Private m_SummaryToRow As Hashtable
    ''' HashTable which maps items of position with their rows in m_PositionsGrid grid
    Private m_PositionToRow As Hashtable


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblDataConnection As System.Windows.Forms.Label
    Friend WithEvents llWeb As System.Windows.Forms.LinkLabel
    Friend WithEvents lblGWConnection As System.Windows.Forms.Label
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox4 As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
    Friend WithEvents gbProperties As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents gbSummaries As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox5 As System.Windows.Forms.GroupBox
    Friend WithEvents lstCurrencies As System.Windows.Forms.ListBox
    Friend WithEvents lstAccounts As System.Windows.Forms.ListBox
    Friend WithEvents GroupBox7 As System.Windows.Forms.GroupBox
    Friend WithEvents gbPositions As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox6 As System.Windows.Forms.GroupBox
    Friend WithEvents lstPositions As System.Windows.Forms.ListBox
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents ctxAccountsDetMenu As System.Windows.Forms.ContextMenu
    Friend WithEvents cmbMarginsDetailingLevel As System.Windows.Forms.ComboBox
    Friend WithEvents label1 As System.Windows.Forms.Label
   <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
      Me.lblDataConnection = New System.Windows.Forms.Label
      Me.llWeb = New System.Windows.Forms.LinkLabel
      Me.lblGWConnection = New System.Windows.Forms.Label
      Me.GroupBox2 = New System.Windows.Forms.GroupBox
      Me.lstAccounts = New System.Windows.Forms.ListBox
      Me.GroupBox4 = New System.Windows.Forms.GroupBox
      Me.gbProperties = New System.Windows.Forms.GroupBox
      Me.GroupBox3 = New System.Windows.Forms.GroupBox
      Me.GroupBox1 = New System.Windows.Forms.GroupBox
      Me.GroupBox5 = New System.Windows.Forms.GroupBox
      Me.lstCurrencies = New System.Windows.Forms.ListBox
      Me.gbSummaries = New System.Windows.Forms.GroupBox
      Me.GroupBox7 = New System.Windows.Forms.GroupBox
      Me.gbPositions = New System.Windows.Forms.GroupBox
      Me.GroupBox6 = New System.Windows.Forms.GroupBox
      Me.lstPositions = New System.Windows.Forms.ListBox
      Me.PictureBox1 = New System.Windows.Forms.PictureBox
      Me.ctxAccountsDetMenu = New System.Windows.Forms.ContextMenu
      Me.cmbMarginsDetailingLevel = New System.Windows.Forms.ComboBox
      Me.label1 = New System.Windows.Forms.Label
      Me.GroupBox2.SuspendLayout()
      Me.gbProperties.SuspendLayout()
      Me.GroupBox1.SuspendLayout()
      Me.GroupBox5.SuspendLayout()
      Me.GroupBox7.SuspendLayout()
      Me.GroupBox6.SuspendLayout()
      Me.SuspendLayout()
      '
      'lblDataConnection
      '
      Me.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
      Me.lblDataConnection.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.lblDataConnection.Location = New System.Drawing.Point(40, 8)
      Me.lblDataConnection.Name = "lblDataConnection"
      Me.lblDataConnection.Size = New System.Drawing.Size(216, 16)
      Me.lblDataConnection.TabIndex = 17
      Me.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
      '
      'llWeb
      '
      Me.llWeb.BackColor = System.Drawing.SystemColors.Control
      Me.llWeb.LinkArea = New System.Windows.Forms.LinkArea(18, 40)
      Me.llWeb.Location = New System.Drawing.Point(704, 8)
      Me.llWeb.Name = "llWeb"
      Me.llWeb.Size = New System.Drawing.Size(336, 16)
      Me.llWeb.TabIndex = 22
      Me.llWeb.TabStop = True
      Me.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx"
      Me.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
      '
      'lblGWConnection
      '
      Me.lblGWConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
      Me.lblGWConnection.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.lblGWConnection.Location = New System.Drawing.Point(312, 8)
      Me.lblGWConnection.Name = "lblGWConnection"
      Me.lblGWConnection.Size = New System.Drawing.Size(216, 16)
      Me.lblGWConnection.TabIndex = 48
      Me.lblGWConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
      '
      'GroupBox2
      '
      Me.GroupBox2.Controls.Add(Me.lstAccounts)
      Me.GroupBox2.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.GroupBox2.Location = New System.Drawing.Point(8, 48)
      Me.GroupBox2.Name = "GroupBox2"
      Me.GroupBox2.Size = New System.Drawing.Size(1072, 128)
      Me.GroupBox2.TabIndex = 51
      Me.GroupBox2.TabStop = False
      Me.GroupBox2.Text = "Accounts"
      '
      'lstAccounts
      '
      Me.lstAccounts.Font = New System.Drawing.Font("Courier New", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.lstAccounts.ItemHeight = 16
      Me.lstAccounts.Location = New System.Drawing.Point(8, 20)
      Me.lstAccounts.Name = "lstAccounts"
      Me.lstAccounts.Size = New System.Drawing.Size(1056, 100)
      Me.lstAccounts.TabIndex = 1
      '
      'GroupBox4
      '
      Me.GroupBox4.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.GroupBox4.Location = New System.Drawing.Point(8, 296)
      Me.GroupBox4.Name = "GroupBox4"
      Me.GroupBox4.Size = New System.Drawing.Size(816, 240)
      Me.GroupBox4.TabIndex = 45
      Me.GroupBox4.TabStop = False
      '
      'gbProperties
      '
      Me.gbProperties.Controls.Add(Me.GroupBox3)
      Me.gbProperties.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.gbProperties.Location = New System.Drawing.Point(8, 176)
      Me.gbProperties.Name = "gbProperties"
      Me.gbProperties.Size = New System.Drawing.Size(472, 288)
      Me.gbProperties.TabIndex = 51
      Me.gbProperties.TabStop = False
      Me.gbProperties.Text = "Account's Properties"
      '
      'GroupBox3
      '
      Me.GroupBox3.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.GroupBox3.Location = New System.Drawing.Point(8, 296)
      Me.GroupBox3.Name = "GroupBox3"
      Me.GroupBox3.Size = New System.Drawing.Size(816, 240)
      Me.GroupBox3.TabIndex = 45
      Me.GroupBox3.TabStop = False
      '
      'GroupBox1
      '
      Me.GroupBox1.Controls.Add(Me.GroupBox5)
      Me.GroupBox1.Controls.Add(Me.gbSummaries)
      Me.GroupBox1.Font = New System.Drawing.Font("Arial", 9.75!)
      Me.GroupBox1.Location = New System.Drawing.Point(488, 224)
      Me.GroupBox1.Name = "GroupBox1"
      Me.GroupBox1.Size = New System.Drawing.Size(592, 448)
      Me.GroupBox1.TabIndex = 55
      Me.GroupBox1.TabStop = False
      Me.GroupBox1.Text = "Account's Summaries"
      '
      'GroupBox5
      '
      Me.GroupBox5.Controls.Add(Me.lstCurrencies)
      Me.GroupBox5.Font = New System.Drawing.Font("Arial", 8.25!)
      Me.GroupBox5.Location = New System.Drawing.Point(504, 16)
      Me.GroupBox5.Name = "GroupBox5"
      Me.GroupBox5.Size = New System.Drawing.Size(80, 408)
      Me.GroupBox5.TabIndex = 56
      Me.GroupBox5.TabStop = False
      Me.GroupBox5.Text = "Currencies"
      '
      'lstCurrencies
      '
      Me.lstCurrencies.ItemHeight = 14
      Me.lstCurrencies.Location = New System.Drawing.Point(8, 24)
      Me.lstCurrencies.Name = "lstCurrencies"
      Me.lstCurrencies.Size = New System.Drawing.Size(64, 368)
      Me.lstCurrencies.TabIndex = 0
      '
      'gbSummaries
      '
      Me.gbSummaries.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.gbSummaries.Location = New System.Drawing.Point(8, 16)
      Me.gbSummaries.Name = "gbSummaries"
      Me.gbSummaries.Size = New System.Drawing.Size(489, 408)
      Me.gbSummaries.TabIndex = 55
      Me.gbSummaries.TabStop = False
      '
      'GroupBox7
      '
      Me.GroupBox7.Controls.Add(Me.gbPositions)
      Me.GroupBox7.Controls.Add(Me.GroupBox6)
      Me.GroupBox7.Font = New System.Drawing.Font("Arial", 9.75!)
      Me.GroupBox7.Location = New System.Drawing.Point(8, 464)
      Me.GroupBox7.Name = "GroupBox7"
      Me.GroupBox7.Size = New System.Drawing.Size(472, 264)
      Me.GroupBox7.TabIndex = 58
      Me.GroupBox7.TabStop = False
      Me.GroupBox7.Text = "Account's Positions"
      '
      'gbPositions
      '
      Me.gbPositions.Font = New System.Drawing.Font("Arial", 9.5!)
      Me.gbPositions.Location = New System.Drawing.Point(168, 16)
      Me.gbPositions.Name = "gbPositions"
      Me.gbPositions.Size = New System.Drawing.Size(296, 232)
      Me.gbPositions.TabIndex = 59
      Me.gbPositions.TabStop = False
      '
      'GroupBox6
      '
      Me.GroupBox6.Controls.Add(Me.lstPositions)
      Me.GroupBox6.Font = New System.Drawing.Font("Arial", 8.25!)
      Me.GroupBox6.Location = New System.Drawing.Point(8, 16)
      Me.GroupBox6.Name = "GroupBox6"
      Me.GroupBox6.Size = New System.Drawing.Size(152, 232)
      Me.GroupBox6.TabIndex = 58
      Me.GroupBox6.TabStop = False
      Me.GroupBox6.Text = "Positions"
      '
      'lstPositions
      '
      Me.lstPositions.HorizontalScrollbar = True
      Me.lstPositions.ItemHeight = 14
      Me.lstPositions.Location = New System.Drawing.Point(8, 16)
      Me.lstPositions.Name = "lstPositions"
      Me.lstPositions.Size = New System.Drawing.Size(136, 200)
      Me.lstPositions.TabIndex = 1
      '
      'PictureBox1
      '
      Me.PictureBox1.BackColor = System.Drawing.Color.Black
      Me.PictureBox1.Location = New System.Drawing.Point(0, 32)
      Me.PictureBox1.Name = "PictureBox1"
      Me.PictureBox1.Size = New System.Drawing.Size(1208, 8)
      Me.PictureBox1.TabIndex = 59
      Me.PictureBox1.TabStop = False
      '
      'cmbMarginsDetailingLevel
      '
      Me.cmbMarginsDetailingLevel.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
      Me.cmbMarginsDetailingLevel.Location = New System.Drawing.Point(864, 184)
      Me.cmbMarginsDetailingLevel.Name = "cmbMarginsDetailingLevel"
      Me.cmbMarginsDetailingLevel.Size = New System.Drawing.Size(214, 21)
      Me.cmbMarginsDetailingLevel.TabIndex = 62
      '
      'label1
      '
      Me.label1.AutoSize = True
      Me.label1.Location = New System.Drawing.Point(688, 192)
      Me.label1.Name = "label1"
      Me.label1.Size = New System.Drawing.Size(178, 16)
      Me.label1.TabIndex = 63
      Me.label1.Text = "All accounts margin detailing level:"
      '
      'frmAccountsAndPositions
      '
      Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
      Me.BackColor = System.Drawing.SystemColors.Control
      Me.ClientSize = New System.Drawing.Size(1090, 736)
      Me.Controls.Add(Me.cmbMarginsDetailingLevel)
      Me.Controls.Add(Me.label1)
      Me.Controls.Add(Me.PictureBox1)
      Me.Controls.Add(Me.GroupBox7)
      Me.Controls.Add(Me.GroupBox1)
      Me.Controls.Add(Me.gbProperties)
      Me.Controls.Add(Me.GroupBox2)
      Me.Controls.Add(Me.lblGWConnection)
      Me.Controls.Add(Me.lblDataConnection)
      Me.Controls.Add(Me.llWeb)
      Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
      Me.MaximizeBox = False
      Me.Name = "frmAccountsAndPositions"
      Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
      Me.Text = "Accounts and Positions"
      Me.GroupBox2.ResumeLayout(False)
      Me.gbProperties.ResumeLayout(False)
      Me.GroupBox1.ResumeLayout(False)
      Me.GroupBox5.ResumeLayout(False)
      Me.GroupBox7.ResumeLayout(False)
      Me.GroupBox6.ResumeLayout(False)
      Me.ResumeLayout(False)

   End Sub

#End Region

    ''' <summary>
    ''' Creates an m_CEL object, change its configurations, starts up and initializes HashTable and grids.
    ''' </summary>
    ''' <param name="sender">
    ''' The source of the event.
    ''' </param>
    ''' <param name="e">
    ''' An EventArgs that contains the event data.
    ''' </param>
    Private Sub frmAccountsAndPositions_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      Try
         InitHashTables()
         InitPropertyFields()
         InitSummariesFields()
         InitPositionsFields()
         InitMarginsDetailingSelectors()

         CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown)
         CEL_GWConnectionStatusChanged(eConnectionStatus.csConnectionDown)

         m_CEL = New CQGCEL
         m_CEL.APIConfiguration.CollectionsThrowException = False
         m_CEL.APIConfiguration.DefPositionSubscriptionLevel = ePositionSubscriptionLevel.pslSnapshotAndUpdates
         m_CEL.APIConfiguration.FireEventOnChangedPrices = True
         m_CEL.APIConfiguration.UseOrderSide = True
         m_CEL.APIConfiguration.PositionDetailing = ePositionDetailing.pdAllTrades
         m_CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff
         m_CEL.APIConfiguration.DefaultAccountMarginDetailing = eAccountMarginDetailing.amdNoMargin
         m_CEL.Startup()
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "frmAccountsAndPositions_Load", ex)
      End Try
    End Sub

   ''' <summary>
   ''' Initializes the margins detailing level combobox and the context menu
   ''' </summary>
   Private Sub InitMarginsDetailingSelectors()
      Dim contextMenuItemEventHandler As EventHandler = New EventHandler(AddressOf ctxAccountsDetMenu_ItemClicked)
      cmbMarginsDetailingLevel.Items.Add(String.Empty)
      For Each curMarginDetailing As eAccountMarginDetailing In [Enum].GetValues(GetType(eAccountMarginDetailing))
         Dim item As String = GetAccountMarginDetailingAsString(curMarginDetailing)
         ctxAccountsDetMenu.MenuItems.Add(item, contextMenuItemEventHandler)
         cmbMarginsDetailingLevel.Items.Add(item)
      Next

      cmbMarginsDetailingLevel.Enabled = False
   End Sub

   ''' <summary>
   ''' Initializes the HashTables.
   ''' </summary>
   Private Sub InitHashTables()
      m_PropertyToRow = New Hashtable
      m_PropertyToRow.Add(DATE_OF_LAST_STATEMENT, 0)
      m_PropertyToRow.Add(FCM_ACCOUNT_ID, 1)
      m_PropertyToRow.Add(FCM_ID, 2)
      m_PropertyToRow.Add(FCM_NAME, 3)
      m_PropertyToRow.Add(GW_ACCOUNT_ID, 4)
      m_PropertyToRow.Add(GW_ACCOUNT_NAME, 5)
      m_PropertyToRow.Add(POSITION_SUBSCRIPTION_LEVEL, 6)
      m_PropertyToRow.Add(REPORTING_CURRENCY, 7)
      m_PropertyToRow.Add(SERVER_TIMESTAMP, 8)
      m_PropertyToRow.Add(TIMESTAMP, 9)
      m_PropertyToRow.Add(TOTAL_MARGIN, 10)
      m_PropertyToRow.Add(PURCHASING_POWER, 11)
      m_PropertyToRow.Add(MARGIN_DETAILING, 12)

      m_SummaryToRow = New Hashtable
      m_SummaryToRow.Add(ACCOUNT_BALANCE, 1)
      m_SummaryToRow.Add(INITIAL_MARGIN, 2)
      m_SummaryToRow.Add(MAINTENANCE_MARGIN, 3)
      m_SummaryToRow.Add(OPEN_TRADE_EQUITY, 4)
      m_SummaryToRow.Add(UNREALIZED_PROFIT_LOSS_FOR_OPTIONS, 5)
      m_SummaryToRow.Add(COLLATERAL_ON_DEPOSIT, 6)
      m_SummaryToRow.Add(NET_LIQUIDITY_VALUE, 7)
      m_SummaryToRow.Add(MARKET_VALUE_OF_OPTIONS, 8)
      m_SummaryToRow.Add(CASH_EXCESS, 9)

      m_PositionToRow = New Hashtable
      m_PositionToRow.Add(AVERAGE_PRICE, 0)
      m_PositionToRow.Add(MARKET_VALUE_OPTION, 1)
      m_PositionToRow.Add(OPEN_TRADE_EQUITY, 2)
      m_PositionToRow.Add(PROFIT_LOSS, 3)
      m_PositionToRow.Add(LONG_, 4)
      m_PositionToRow.Add(SHORT_, 5)
      m_PositionToRow.Add(OFFSET, 6)
      m_PositionToRow.Add(SERVER_TIMESTAMP, 7)
      m_PositionToRow.Add(TIMESTAMP, 8)
      m_PositionToRow.Add(CURRENCY, 9)

   End Sub

   ''' <summary>
   ''' Creates and initializes the grid of properties.
   ''' </summary>
   Private Sub InitPropertyFields()
      m_PropertiesGrid = New CQGMiniGrid(2, m_PropertyToRow.Count, gbProperties)

      m_PropertiesGrid.ColumnWidth(0) = 172
      m_PropertiesGrid.ColumnWidth(1) = 278

      m_PropertiesGrid.HeaderValue(0) = "Property Name"
      m_PropertiesGrid.HeaderValue(1) = "Value"

      For Each item As DictionaryEntry In m_PropertyToRow
         m_PropertiesGrid.Item(CType(item.Value, Integer), 0).Text = CType(item.Key, String)
      Next

      m_PropertiesGrid.ReDraw()
   End Sub

   ''' <summary>
   ''' Creates and initializes the grid of summaries.
   ''' </summary>
   Private Sub InitSummariesFields()
      Dim itemsCount As Integer = m_SummaryToRow.Count + 1

      m_SummariesGrid = New CQGMiniGrid(3, itemsCount * 2, gbSummaries)

      m_SummariesGrid.ColumnWidth(0) = 225
      m_SummariesGrid.ColumnAlign(0) = ContentAlignment.MiddleLeft
      m_SummariesGrid.HeaderValue(0) = ""

      m_SummariesGrid.ColumnWidth(1) = 125
      m_SummariesGrid.ColumnAlign(1) = ContentAlignment.MiddleRight
      m_SummariesGrid.HeaderValue(1) = "Total"

      m_SummariesGrid.ColumnWidth(2) = 125
      m_SummariesGrid.ColumnAlign(2) = ContentAlignment.MiddleRight
      m_SummariesGrid.HeaderValue(2) = ""

      m_SummariesGrid.Item(0, 0).Text = "CURRENT VALUES"
      m_SummariesGrid.Item(0, 0).TextAlign = ContentAlignment.MiddleCenter
      m_SummariesGrid.Item(0, 0).Font = New Font("Arial", 10, FontStyle.Italic)

      m_SummariesGrid.Item(itemsCount, 0).Text = "YESTERDAY'S CLOSE VALUES"
      m_SummariesGrid.Item(itemsCount, 0).TextAlign = ContentAlignment.MiddleCenter
      m_SummariesGrid.Item(itemsCount, 0).Font = New Font("Arial", 10, FontStyle.Italic)

      Dim row As Integer
      For Each item As DictionaryEntry In m_SummaryToRow
         ' Every item here must be added twice: for current values and yesterdays close values
         ' Also we are adding 1, because we have headers seperated from the hashtable
         For i As Integer = 0 To 1
            row = CType(item.Value, Integer) + itemsCount * i
            m_SummariesGrid.Item(row, 0).Text = CType(item.Key, String)
         Next
      Next

      m_SummariesGrid.ReDraw()
   End Sub

   ''' <summary>
   ''' Create and initialize the grid of positions.
   ''' </summary>
   Private Sub InitPositionsFields()
      m_PositionsGrid = New CQGMiniGrid(2, m_PositionToRow.Count, gbPositions)

      m_PositionsGrid.ColumnWidth(0) = 130
      m_PositionsGrid.ColumnAlign(0) = ContentAlignment.MiddleLeft
      m_PositionsGrid.HeaderValue(0) = "Properties"

      m_PositionsGrid.ColumnWidth(1) = 150
      m_PositionsGrid.ColumnAlign(1) = ContentAlignment.MiddleLeft
      m_PositionsGrid.HeaderValue(1) = "Value"

      For Each item As DictionaryEntry In m_PositionToRow
         m_PositionsGrid.Item(CType(item.Value, Integer), 0).Text = CType(item.Key, String)
      Next

      m_PositionsGrid.ReDraw()
   End Sub

   ''' <summary>
   ''' Shuts down m_CEL.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' A CancelEventArgs that contains the event data.
   ''' </param>
   Private Sub frmAccountsAndPositions_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
      Try
         m_CEL.Shutdown()
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "frmAccountsAndPositions_Closing", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired, when some changes occur in the connection with the CQG data server.
   ''' </summary>
   ''' <param name="newStatus">
   ''' The current status of the connection with the data server.
   ''' </param>
   Private Sub CEL_DataConnectionStatusChanged(ByVal newStatus As eConnectionStatus) Handles m_CEL.DataConnectionStatusChanged
      Try
         Dim info As String
         Dim BackCol As System.Drawing.Color

         If newStatus <> eConnectionStatus.csConnectionUp Then
            BackCol = System.Drawing.Color.FromArgb(255, 114, 0)
            info = "DATA Connection is " & IIf(newStatus = eConnectionStatus.csConnectionDelayed, _
                                                                                    "Delayed", "Down").ToString()
         Else
            BackCol = System.Drawing.Color.FromArgb(192, 209, 205)
            info = "DATA Connection is UP"
         End If

         lblDataConnection.BackColor = BackCol
         lblDataConnection.Text = info
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "CEL_DataConnectionStatusChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired when the status of the connection with the CQG Gateway is changed.
   ''' </summary>
   ''' <param name="newStatus">
   ''' The current status of the connection with CQG Gateway.
   ''' </param>
   Private Sub CEL_GWConnectionStatusChanged(ByVal newStatus As CQG.eConnectionStatus) Handles m_CEL.GWConnectionStatusChanged
      Try
         Dim info As String
         Dim BackCol As System.Drawing.Color

         If newStatus <> eConnectionStatus.csConnectionUp Then
            BackCol = System.Drawing.Color.FromArgb(255, 114, 0)
            info = "GW Connection is " & IIf(newStatus = eConnectionStatus.csConnectionDelayed, _
                                                                                    "Delayed", "Down").ToString()
            ' Clearing all shown data, because after GW connection up we will receive all data again.
            lstAccounts.Items.Clear()
            DisplayProperties(Nothing, False)
         Else
            BackCol = System.Drawing.Color.FromArgb(192, 209, 205)
            info = "GW Connection is UP"
            m_CEL.AccountSubscriptionLevel = eAccountSubscriptionLevel.aslAccountsAndUpdates
         End If

         lblGWConnection.BackColor = BackCol
         lblGWConnection.Text = info
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "CEL_GWConnectionStatusChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired, when the account or position information is changed.
   ''' </summary>
   ''' <param name="change">
   ''' Account change type, which allows to differentiate the occurred changes. 
   ''' </param>
   ''' <param name="Account">
   ''' A CQGAccount object, representing the account to which the current change refers.
   ''' </param>
   ''' <param name="position">
   ''' A CQGPosition object, representing the position to which the current change refers.
   ''' </param>
   Private Sub CEL_AccountChanged(ByVal change As CQG.eAccountChangeType, _
                                       ByVal account As CQGAccount, _
                                       ByVal position As CQG.CQGPosition) _
                                       Handles m_CEL.AccountChanged
      Try
         Select Case change
            Case eAccountChangeType.actAccountsReloaded
               lstAccounts.Items.Clear()
               For Each acc As CQGAccount In m_CEL.Accounts
                  lstAccounts.Items.Add(CStr(acc.GWAccountID).PadRight(LIST_ACC_COL_WIDTH) & _
                                              acc.GWAccountName.PadRight(LIST_ACC_COL_WIDTH) & _
                                              acc.FcmAccountID.PadRight(LIST_ACC_COL_WIDTH) & _
                                              CStr(acc.FcmID).PadRight(LIST_ACC_COL_WIDTH))
                  acc.AutoSubscribeInstruments = True
               Next
               lstAccounts.SelectedIndex = 0
               cmbMarginsDetailingLevel.Enabled = True
               cmbMarginsDetailingLevel.Text = GetAccountMarginDetailingAsString(m_CEL.APIConfiguration.DefaultAccountMarginDetailing)
            Case eAccountChangeType.actAccountChanged
               If account.GWAccountID = GetSelectedGWID() Then
                  DisplayProperties(account, False)
               End If
            Case eAccountChangeType.actPositionsReloaded
               If account.GWAccountID = GetSelectedGWID() Then
                  DisplaySummaries(account.CurrencySummaries, False)
                  DisplaySummary(account.Summary, 1)

                  DisplayPositions(account.Positions)
                  If lstPositions.Items.Count > 0 Then
                     lstPositions.SelectedIndex = 0
                  End If
               End If
            Case eAccountChangeType.actPositionChanged
               If account.GWAccountID = GetSelectedGWID() Then
                  DisplaySummaries(account.CurrencySummaries, False)
                  DisplaySummary(account.Summary, 1)

                  If position.InstrumentName = GetListboxText(lstPositions) Then
                     DisplayPosition(position)
                  End If
               End If
            Case eAccountChangeType.actPositionAdded
               If account.GWAccountID = GetSelectedGWID() Then
                  DisplaySummaries(account.CurrencySummaries, False)
                  DisplaySummary(account.Summary, 1)

                  lstPositions.Items.Add(position.InstrumentName)
                  If lstPositions.Items.Count = 1 Then
                     lstPositions.SelectedIndex = 0
                  End If
               End If

         End Select
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "CEL_AccountChanged", ex)
      End Try
   End Sub
   ''' <summary>
   ''' This event is fired when a new instrument is resolved and subscribed.
   ''' </summary>
   ''' <param name="symbol">
   ''' The commodity symbol that was requested by user in NewInstrument method. 
   ''' </param>
   ''' <param name="Instrument">
   ''' Resolved CQGInstrument object
   ''' </param>
   ''' <param name="cqg_error">
   ''' Error happened during a resolution process
   ''' </param>
   Private Sub CEL_InstrumentResolved(ByVal symbol As String, ByVal instrument As CQG.CQGInstrument, ByVal cqg_error As CQG.CQGError) Handles m_CEL.InstrumentResolved
      Try
         If Not m_CEL.IsValid(cqg_error) Then
            Dim selectedGWID As Integer = GetSelectedGWID()
            If selectedGWID > 0 Then
               DisplayPosition(m_CEL.Accounts(selectedGWID).Positions(GetListboxText(lstPositions)))
            End If
         Else
            HandleError("frmAccountsAndPositions", "CEL_InstrumentResolved", cqg_error)
         End If
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "CEL_InstrumentResolved", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
   ''' </summary>
   ''' <param name="obj">
   ''' Object, in which the error occurred.
   ''' </param>
   ''' <param name="errorDescription">
   ''' String, describing the error.
   ''' </param>
   Private Sub CEL_DataError(ByVal obj As Object, ByVal errorDescription As String) Handles m_CEL.DataError
      Try
         Dim cqgErr As CQGError = TryCast(obj, CQGError)
         If m_CEL.IsValid(cqgErr) Then
            If cqgErr.Code = 102 Then
               errorDescription &= " Restart the application."
            ElseIf cqgErr.Code = 125 Then
               errorDescription &= " Turn on CQG Client and restart the application."
            End If
         End If

         MessageBox.Show(errorDescription, "AccountsAndPositions", MessageBoxButtons.OK, MessageBoxIcon.Information)
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "CEL_DataError", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Displays all available data for given account.
   ''' </summary>
   ''' <param name="acc">
   ''' Account, which data must be shown.
   ''' </param>
   ''' <param name="reloaded">
   ''' Boolean parameter, which shows if info must be shown for the first time, or must be updated
   ''' </param>
   Private Sub DisplayProperties(ByVal acc As CQGAccount, ByVal reloaded As Boolean)
      If acc Is Nothing Then
         m_PropertiesGrid.ClearColumn(1)
         DisplaySummaries(Nothing, False)
         DisplayPositions(Nothing)
         Return
      End If

      DisplaySummaries(acc.CurrencySummaries, reloaded)
      DisplayPositions(acc.Positions)
      If m_CEL.IsValid(acc.DateOfLastStatement) Then
         m_PropertiesGrid.Item(CType(m_PropertyToRow(DATE_OF_LAST_STATEMENT), Integer), 1).Text = acc.DateOfLastStatement.ToShortDateString()
      Else
         m_PropertiesGrid.Item(CType(m_PropertyToRow(DATE_OF_LAST_STATEMENT), Integer), 1).Text = N_A
      End If
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(FCM_ACCOUNT_ID)), 1).Text = acc.FcmAccountID
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(FCM_ID)), 1).Text = acc.FcmID.ToString()
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(FCM_NAME)), 1).Text = acc.FcmName
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(GW_ACCOUNT_ID)), 1).Text = acc.GWAccountID.ToString()
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(GW_ACCOUNT_NAME)), 1).Text = acc.GWAccountName
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(POSITION_SUBSCRIPTION_LEVEL)), 1).Text = acc.PositionSubcriptionLevel.ToString()
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(REPORTING_CURRENCY)), 1).Text = acc.ReportingCurrency
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(TIMESTAMP)), 1).Text = ValToString(acc.Timestamp)
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(SERVER_TIMESTAMP)), 1).Text = ValToString(acc.ServerTimestamp)
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(TOTAL_MARGIN)), 1).Text = ValToString(acc.TotalMarginValue)
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(PURCHASING_POWER)), 1).Text = ValToString(acc.TotalPurchasingPower)
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(MARGIN_DETAILING)), 1).Text = GetAccountMarginDetailingAsString(acc.AccountMarginDetailing)

      DisplaySummary(acc.Summary, 1)

   End Sub

   ''' <summary>
   ''' If param "reloaded" is true, adds currencies of all summaries to listbox and 
   ''' shows all available data for the first summary.
   ''' </summary>
   ''' <param name="summaries">
   ''' Collection of all available summaries for the selected account
   ''' </param>
   ''' <param name="reloaded">
   ''' Boolean parameter, which shows if info must be shown for the first time, or must be updated
   ''' </param>
   Private Sub DisplaySummaries(ByVal summaries As CQGAccountSummaries, ByVal reloaded As Boolean)
      If summaries Is Nothing Then
         m_SummariesGrid.ClearColumn(1)
         m_SummariesGrid.ClearColumn(2)
         lstCurrencies.Items.Clear()
         Return
      End If

      If reloaded Then
         lstCurrencies.Items.Clear()
         For Each summary As CQGAccountSummary In summaries
            lstCurrencies.Items.Add(summary.CurrencyName)
         Next
         If lstCurrencies.Items.Count > 0 Then
            lstCurrencies.SelectedIndex = 0
         Else
            m_SummariesGrid.ClearColumn(2)
         End If
         m_SummariesGrid.HeaderValue(2) = GetListboxText(lstCurrencies)
      End If

      For Each summary As CQGAccountSummary In summaries
         If Summary.CurrencyName = GetListboxText(lstCurrencies) Then
            DisplaySummary(Summary, 2)
            Exit For
         End If
      Next
   End Sub

   ''' <summary>
   ''' Displays all available data for the given summary.
   ''' </summary>
   ''' <param name="summary">
   ''' Summary, which data must be shown.
   ''' </param>
   ''' <param name="col">
   ''' Column in which data must be dumped.
   ''' </param>
   Private Sub DisplaySummary(ByVal summary As CQGAccountSummary, ByVal col As Integer)
      Dim row As Integer

      For i As Integer = 0 To 1
         Dim summaryStartRow As Integer = (m_SummaryToRow.Count + 1) * i

         If i = 1 Then
            row = CType(m_SummaryToRow(COLLATERAL_ON_DEPOSIT), Integer) + summaryStartRow
            m_SummariesGrid.Item(row, col).Text = ValToString(summary.Collaterals(i))

            row = CType(m_SummaryToRow(CASH_EXCESS), Integer) + summaryStartRow
            m_SummariesGrid.Item(row, col).Text = ValToString(summary.CashExcess(i))

            row = CType(m_SummaryToRow(INITIAL_MARGIN), Integer) + summaryStartRow
            m_SummariesGrid.Item(row, col).Text = ValToString(summary.InitialMargin(i))

            row = CType(m_SummaryToRow(MAINTENANCE_MARGIN), Integer) + summaryStartRow
            m_SummariesGrid.Item(row, col).Text = ValToString(summary.MaintenanceMargin(i))
         Else
            row = CType(m_SummaryToRow(COLLATERAL_ON_DEPOSIT), Integer) + summaryStartRow
            m_SummariesGrid.Item(row, col).Text = N_A

            row = CType(m_SummaryToRow(CASH_EXCESS), Integer) + summaryStartRow
            m_SummariesGrid.Item(row, col).Text = N_A

            row = CType(m_SummaryToRow(INITIAL_MARGIN), Integer) + summaryStartRow
            m_SummariesGrid.Item(row, col).Text = N_A

            row = CType(m_SummaryToRow(MAINTENANCE_MARGIN), Integer) + summaryStartRow
            m_SummariesGrid.Item(row, col).Text = N_A
         End If

         row = CType(m_SummaryToRow(ACCOUNT_BALANCE), Integer) + summaryStartRow
         m_SummariesGrid.Item(row, col).Text = ValToString(summary.Balance(i))

         row = CType(m_SummaryToRow(MARKET_VALUE_OF_OPTIONS), Integer) + summaryStartRow
         m_SummariesGrid.Item(row, col).Text = ValToString(summary.MVO(i))

         row = CType(m_SummaryToRow(NET_LIQUIDITY_VALUE), Integer) + summaryStartRow
         m_SummariesGrid.Item(row, col).Text = ValToString(summary.NLV(i))

         row = CType(m_SummaryToRow(OPEN_TRADE_EQUITY), Integer) + summaryStartRow
         m_SummariesGrid.Item(row, col).Text = ValToString(summary.OTE(i))

         row = CType(m_SummaryToRow(UNREALIZED_PROFIT_LOSS_FOR_OPTIONS), Integer) + summaryStartRow
         m_SummariesGrid.Item(row, col).Text = ValToString(summary.UPL(i))

      Next
   End Sub

   ''' <summary>
   ''' Adds all positions' instrument's fullnames to listbox.
   ''' </summary>
   ''' <param name="positions">
   ''' Collection of all available positions for selected account
   ''' </param>
   Private Sub DisplayPositions(ByVal positions As CQGPositions)
      lstPositions.Items.Clear()
      m_PositionsGrid.ClearColumn(1)

      If positions Is Nothing Then
         DisplayPosition(Nothing)
         Return
      End If

      For Each pos As CQGPosition In positions
         lstPositions.Items.Add(pos.InstrumentName)
      Next
   End Sub

   ''' <summary>
   ''' Displays all available data for the given position.
   ''' </summary>
   ''' <param name="pos">
   ''' Position, which data must be shown.
   ''' </param>
   Private Sub DisplayPosition(ByVal pos As CQGPosition)
      If pos Is Nothing Then
         m_PositionsGrid.ClearColumn(1)
         Return
      End If

      m_PositionsGrid.Item(CType(m_PositionToRow(MARKET_VALUE_OPTION), Integer), 1).Text = ValToString(pos.MVO)
      m_PositionsGrid.Item(CType(m_PositionToRow(OPEN_TRADE_EQUITY), Integer), 1).Text = ValToString(pos.OTE)
      m_PositionsGrid.Item(CType(m_PositionToRow(PROFIT_LOSS), Integer), 1).Text = ValToString(pos.ProfitLoss)

      Dim quantity As String = IIf(pos.Quantity = 0, "-", pos.Quantity).ToString()
      If pos.Side = eOrderSide.osdBuy Then
         m_PositionsGrid.Item(CType(m_PositionToRow(SHORT_), Integer), 1).Text = "-"
         m_PositionsGrid.Item(CType(m_PositionToRow(LONG_), Integer), 1).Text = quantity
      Else
         m_PositionsGrid.Item(CType(m_PositionToRow(SHORT_), Integer), 1).Text = quantity
         m_PositionsGrid.Item(CType(m_PositionToRow(LONG_), Integer), 1).Text = "-"
      End If

      If Not pos.MatchedTrades Is Nothing Then
         Dim lOffset As Long = 0
         For Each Trade As CQGTrade In pos.MatchedTrades
            lOffset += Trade.Quantity
         Next
         m_PositionsGrid.Item(CType(m_PositionToRow(OFFSET), Integer), 1).Text = ValToString(lOffset)
      Else
         m_PositionsGrid.Item(CType(m_PositionToRow(OFFSET), Integer), 1).Text = N_A
      End If

      m_PositionsGrid.Item(CType(m_PositionToRow(SERVER_TIMESTAMP), Integer), 1).Text = _
                                                                              ValToString(pos.ServerTimestamp)
      m_PositionsGrid.Item(CType(m_PositionToRow(TIMESTAMP), Integer), 1).Text = ValToString(pos.Timestamp)

      Dim instrument As CQGInstrument = pos.Instrument
      If Not instrument Is Nothing Then
         m_PositionsGrid.Item(CType(m_PositionToRow(CURRENCY), Integer), 1).Text = _
                                                                             ValToString(instrument.Currency)
         If m_CEL.IsValid(pos.AveragePrice) Then
            m_PositionsGrid.Item(CType(m_PositionToRow(AVERAGE_PRICE), Integer), 1).Text = _
                                                        instrument.ToDisplayPrice(pos.AveragePrice)
         Else
            m_PositionsGrid.Item(CType(m_PositionToRow(AVERAGE_PRICE), Integer), 1).Text = N_A
         End If
      Else
         m_PositionsGrid.Item(CType(m_PositionToRow(CURRENCY), Integer), 1).Text = N_A
         m_PositionsGrid.Item(CType(m_PositionToRow(AVERAGE_PRICE), Integer), 1).Text = N_A
      End If
   End Sub

   ''' <summary>
   ''' Displays information for the selected account.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub lstAccounts_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstAccounts.SelectedIndexChanged
      Try
         If GetSelectedGWID() > 0 Then
            lstAccounts.ContextMenu = ctxAccountsDetMenu
            DisplayProperties(m_CEL.Accounts(GetSelectedGWID), True)
         Else
            lstAccounts.ContextMenu = Nothing
         End If
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "lstAccounts_SelectedIndexChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Displays summary for selected currency.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub lstCurrencies_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstCurrencies.SelectedIndexChanged
      Try
         m_SummariesGrid.HeaderValue(2) = GetListboxText(lstCurrencies)
         DisplaySummaries(m_CEL.Accounts(GetSelectedGWID).CurrencySummaries, False)
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "lstCurrencies_SelectedIndexChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Displays position info for the selected instrument.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub lstPositions_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstPositions.SelectedIndexChanged
      Try
         If GetSelectedGWID() > 0 Then
            DisplayPosition(m_CEL.Accounts(GetSelectedGWID).Positions(GetListboxText(lstPositions)))
         End If
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "lstPositions_SelectedIndexChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Open CQG API web page.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' A LinkLabelLinkClickedEventArgs that contains the event data.
   ''' </param>
   Private Sub llWeb_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles llWeb.LinkClicked
      Try
         System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx")
      Catch ex As Exception
         HandleError("frmAccountsAndPositions", "llWeb_LinkClicked", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Converts input param to string.
   ''' </summary>
   ''' <param name="val">
   ''' Input param, which must be converted to string, if is not nothing and is valid.
   ''' </param>
   ''' <returns>
   ''' "0" if input is nothing or is not valid, otherwise input param is converted to string.
   ''' </returns>
   Private Function ValToString(ByVal val As Object) As String
      Dim dispVal As String
      If (Not val Is Nothing) And m_CEL.IsValid(val) Then
         If TypeOf (val) Is Double Then
            dispVal = Format(val, "0.00")
         Else
            dispVal = val.ToString()
         End If
      Else
         dispVal = N_A
      End If

      Return dispVal
   End Function

   ''' <summary>
   ''' Returns GWAccountId for the selected account in lstAccounts.
   ''' </summary>
   ''' <returns>
   ''' 0 if there is no selection, otherwise: GWAccountId
   ''' </returns>
   Private Function GetSelectedGWID() As Integer
      Dim gwID As String = Mid(GetListboxText(lstAccounts), 1, LIST_ACC_COL_WIDTH)

      If Len(Trim(gwID)) = 0 Then
         Return 0
      End If

      Return CType(gwID, Integer)
   End Function

   ''' <summary>
   ''' This function is for workarounding problem of text property(of listbox)
   ''' </summary>
   ''' <param name="lb">
   ''' The listbox, which text must be returned
   ''' </param>
   ''' <returns>
   ''' Text of textbox.
   ''' </returns>
   Private Function GetListboxText(ByVal lb As ListBox) As String
      Dim text As String

      Try
         text = lb.Text
      Catch
         text = ""
      End Try

      Return text
   End Function

   ''' <summary>
   ''' The context menu item click event handler
   ''' </summary>
   ''' <param name="sender">The clicked menu item</param>
   ''' <param name="e">Event arguments</param>
   Private Sub ctxAccountsDetMenu_ItemClicked(ByVal sender As Object, ByVal e As EventArgs)

      Dim clickedItem As MenuItem
      clickedItem = CType(sender, MenuItem)
      Dim level As eAccountMarginDetailing
      level = CType([Enum].Parse(GetType(eAccountMarginDetailing), clickedItem.Text.Insert(0, "amd")), eAccountMarginDetailing)

      Dim account As CQGAccount
      account = m_CEL.Accounts(GetSelectedGWID())
      If Not account Is Nothing Then
         account.AccountMarginDetailing = level
         cmbMarginsDetailingLevel.Text = String.Empty
      End If
   End Sub

   ''' <summary>
   ''' Returns name of account margin detailing level
   ''' </summary>
   ''' <param name="marginDetailing">
   ''' Account margin detailing enum
   ''' </param>
   ''' <returns>Name of detailing level</returns>
   Private Function GetAccountMarginDetailingAsString(ByVal marginDetailing As eAccountMarginDetailing) As String
      ' eAccountMarginDetailing names starts with "amd" (ex.: amdNoMargin), we have to get rid of that to get proper name
      Dim text As String = marginDetailing.ToString()
      If text.StartsWith("amd") Then
         text = text.Substring(3)
      End If

      Return text
   End Function

   ''' <summary>
   ''' The margins detailing level combobox selection index changed event handler
   ''' </summary>
   ''' <param name="sender">The margins detailing level combobox</param>
   ''' <param name="e">The event arguments</param>
   Private Sub cmbMarginsDetailingLevel_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cmbMarginsDetailingLevel.SelectedIndexChanged
      If m_CEL Is Nothing OrElse cmbMarginsDetailingLevel.Text = String.Empty Then
         Exit Sub
      End If

      Dim level As eAccountMarginDetailing _
               = CType([Enum].Parse(GetType(eAccountMarginDetailing), cmbMarginsDetailingLevel.Text.Insert(0, "amd")), eAccountMarginDetailing)
      m_PropertiesGrid.Item(CInt(m_PropertyToRow(MARGIN_DETAILING)), 1).Text = GetAccountMarginDetailingAsString(level)

      For Each account As CQGAccount In m_CEL.Accounts
         account.AccountMarginDetailing = level
      Next
   End Sub

   ''' <summary>
   ''' The context menu population event handler
   ''' </summary>
   ''' <param name="sender">The context menu object</param>
   ''' <param name="e">The event arguments</param>
   Private Sub ctxAccountsDetMenu_Popup(ByVal sender As Object, ByVal e As EventArgs) Handles ctxAccountsDetMenu.Popup

      Dim account As CQGAccount = m_CEL.Accounts(GetSelectedGWID())
      If Not account Is Nothing Then
         Dim level As String = GetAccountMarginDetailingAsString(account.AccountMarginDetailing)
         For Each item As MenuItem In ctxAccountsDetMenu.MenuItems
            item.Checked = CBool(item.Text = level)
         Next
      End If
   End Sub

   ''' <summary>
   ''' The mouse down event handler for accounts listbox.
   ''' </summary>
   ''' <param name="sender">The accounts listbox</param>
   ''' <param name="e">The event arguments</param>
   Private Sub lstAccounts_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs) Handles lstAccounts.MouseDown

      If e.Button = MouseButtons.Right Then
         lstAccounts.SelectedIndex = lstAccounts.IndexFromPoint(e.X, e.Y)
      End If

   End Sub

   Protected Overrides Sub Finalize()
      MyBase.Finalize()
   End Sub
End Class
