// DataSources.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "DataSources.h"
#include "DataSourcesDlg.h"

namespace
{
   class CTEMPORALModule : public ATL::CComModule
   {
   };

   // This instance is auxiliary. It will initialize all COM required
   // modules in its constructor.
   CTEMPORALModule atlTemp;

   // The one and only CDataSourcesApp object
   CDataSourcesApp theApp;
}

BOOL CDataSourcesApp::InitInstance()
{
   CWinApp::InitInstance();

   // InitCommonControls() is required on Windows XP if an application
   // manifest specifies use of ComCtl32.dll version 6 or later to enable
   // visual styles.  Otherwise, any window creation will fail.
   InitCommonControls();

   // Initializes the COM library
   CoInitialize(NULL);

   AfxEnableControlContainer();

   CDataSourcesDlg dlg;
   m_pMainWnd = &dlg;
   dlg.DoModal();

   // Since the dialog has been closed, return FALSE so that we exit the
   // application, rather than start the application's message pump.
   return FALSE;
}

BOOL CDataSourcesApp::ExitInstance()
{
   // Close the COM library and unload all DLLs
   CoUninitialize();

   return CWinApp::ExitInstance();
}
