Imports CQG
Imports System.Runtime.InteropServices

Public Class frmInstrumentProperties
   Inherits System.Windows.Forms.Form

   Private Const N_A As String = "N/A"

   Private WithEvents m_CEL As CQGCEL

   ''' Grids for dumping properties/sessions/quotes/DOM values
   Private m_PropertiesGrid As CQGMiniGrid
   Private m_QuotesGrid As CQGMiniGrid
   Private m_DOMGrid As CQGMiniGrid
   Private m_SessionsGrid As CQGMiniGrid

   ''' Status of controls. This is used to cover case when DataConnection has been lost
   Private m_Status As Boolean
   ''' FullName of selected instrument
   Private m_InstrumentFullName As String
   '''HashTable which maps properties types with their data
   Private m_PropTypeToData As Hashtable
   '''HashTable which maps quote types with their data
   Private m_QuoteTypeToData As Hashtable

   ''' Data holder for instrument properties/quotes
   Structure DataHolder
      Public Sub New(ByVal row As Integer, ByVal name As String)
         Me.Row = row
         Me.Name = name
      End Sub
      ' Row number of the property/quote in the grid
      Public Row As Integer
      ' Property/Quote name
      Public Name As String
   End Structure


#Region " Windows Form Designer generated code "

   Public Sub New()
      MyBase.New()

      'This call is required by the Windows Form Designer.
      InitializeComponent()

      'Add any initialization after the InitializeComponent() call

   End Sub

   'Form overrides dispose to clean up the component list.
   Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
      If disposing Then
         If Not (components Is Nothing) Then
            components.Dispose()
         End If
      End If
      MyBase.Dispose(disposing)
   End Sub

   'Required by the Windows Form Designer
   Private components As System.ComponentModel.IContainer

   'NOTE: The following procedure is required by the Windows Form Designer
   'It can be modified using the Windows Form Designer.  
   'Do not modify it using the code editor.
   Friend WithEvents lblDataConnection As System.Windows.Forms.Label
   Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
   Friend WithEvents llWeb As System.Windows.Forms.LinkLabel
   Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
   Friend WithEvents lstInstruments As System.Windows.Forms.ListBox
   Friend WithEvents btnRemoveAll As System.Windows.Forms.Button
   Friend WithEvents btnRemove As System.Windows.Forms.Button
   Friend WithEvents txtSymbol As System.Windows.Forms.TextBox
   Friend WithEvents Label4 As System.Windows.Forms.Label
   Friend WithEvents btnSubscribe As System.Windows.Forms.Button
   Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
   Friend WithEvents GroupBox5 As System.Windows.Forms.GroupBox
   Friend WithEvents cmbDataSubscriptionLevel As System.Windows.Forms.ComboBox
   Friend WithEvents btnApply As System.Windows.Forms.Button
   Friend WithEvents GroupBox6 As System.Windows.Forms.GroupBox
   Friend WithEvents cmbBBAType As System.Windows.Forms.ComboBox
   Friend WithEvents gbProperties As System.Windows.Forms.GroupBox
   Friend WithEvents gbQuotes As System.Windows.Forms.GroupBox
   Friend WithEvents gbDOM As System.Windows.Forms.GroupBox
   Friend WithEvents gbSessions As System.Windows.Forms.GroupBox
   Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
   Friend WithEvents nudDOMBookLimit As System.Windows.Forms.NumericUpDown
   <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
      Me.lblDataConnection = New System.Windows.Forms.Label
      Me.PictureBox1 = New System.Windows.Forms.PictureBox
      Me.llWeb = New System.Windows.Forms.LinkLabel
      Me.GroupBox2 = New System.Windows.Forms.GroupBox
      Me.GroupBox1 = New System.Windows.Forms.GroupBox
      Me.GroupBox3 = New System.Windows.Forms.GroupBox
      Me.nudDOMBookLimit = New System.Windows.Forms.NumericUpDown
      Me.GroupBox6 = New System.Windows.Forms.GroupBox
      Me.cmbBBAType = New System.Windows.Forms.ComboBox
      Me.GroupBox5 = New System.Windows.Forms.GroupBox
      Me.cmbDataSubscriptionLevel = New System.Windows.Forms.ComboBox
      Me.btnApply = New System.Windows.Forms.Button
      Me.txtSymbol = New System.Windows.Forms.TextBox
      Me.Label4 = New System.Windows.Forms.Label
      Me.btnSubscribe = New System.Windows.Forms.Button
      Me.btnRemoveAll = New System.Windows.Forms.Button
      Me.btnRemove = New System.Windows.Forms.Button
      Me.lstInstruments = New System.Windows.Forms.ListBox
      Me.gbProperties = New System.Windows.Forms.GroupBox
      Me.gbQuotes = New System.Windows.Forms.GroupBox
      Me.gbDOM = New System.Windows.Forms.GroupBox
      Me.gbSessions = New System.Windows.Forms.GroupBox
      Me.GroupBox2.SuspendLayout()
      Me.GroupBox1.SuspendLayout()
      Me.GroupBox3.SuspendLayout()
      CType(Me.nudDOMBookLimit, System.ComponentModel.ISupportInitialize).BeginInit()
      Me.GroupBox6.SuspendLayout()
      Me.GroupBox5.SuspendLayout()
      Me.SuspendLayout()
      '
      'lblDataConnection
      '
      Me.lblDataConnection.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
      Me.lblDataConnection.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.lblDataConnection.Location = New System.Drawing.Point(16, 8)
      Me.lblDataConnection.Name = "lblDataConnection"
      Me.lblDataConnection.Size = New System.Drawing.Size(216, 16)
      Me.lblDataConnection.TabIndex = 17
      Me.lblDataConnection.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
      '
      'PictureBox1
      '
      Me.PictureBox1.BackColor = System.Drawing.Color.Black
      Me.PictureBox1.Location = New System.Drawing.Point(0, 32)
      Me.PictureBox1.Name = "PictureBox1"
      Me.PictureBox1.Size = New System.Drawing.Size(1272, 8)
      Me.PictureBox1.TabIndex = 15
      Me.PictureBox1.TabStop = False
      '
      'llWeb
      '
      Me.llWeb.BackColor = System.Drawing.SystemColors.Control
      Me.llWeb.LinkArea = New System.Windows.Forms.LinkArea(18, 58)
      Me.llWeb.Location = New System.Drawing.Point(656, 8)
      Me.llWeb.Name = "llWeb"
      Me.llWeb.Size = New System.Drawing.Size(408, 16)
      Me.llWeb.TabIndex = 22
      Me.llWeb.TabStop = True
      Me.llWeb.Text = "CQG API web page: http://www.cqg.com/Products/CQG-API.aspx"
      Me.llWeb.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
      '
      'GroupBox2
      '
      Me.GroupBox2.Controls.Add(Me.GroupBox1)
      Me.GroupBox2.Controls.Add(Me.txtSymbol)
      Me.GroupBox2.Controls.Add(Me.Label4)
      Me.GroupBox2.Controls.Add(Me.btnSubscribe)
      Me.GroupBox2.Controls.Add(Me.btnRemoveAll)
      Me.GroupBox2.Controls.Add(Me.btnRemove)
      Me.GroupBox2.Controls.Add(Me.lstInstruments)
      Me.GroupBox2.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.GroupBox2.Location = New System.Drawing.Point(8, 48)
      Me.GroupBox2.Name = "GroupBox2"
      Me.GroupBox2.Size = New System.Drawing.Size(232, 760)
      Me.GroupBox2.TabIndex = 43
      Me.GroupBox2.TabStop = False
      Me.GroupBox2.Text = "Instruments"
      '
      'GroupBox1
      '
      Me.GroupBox1.Controls.Add(Me.GroupBox3)
      Me.GroupBox1.Controls.Add(Me.GroupBox6)
      Me.GroupBox1.Controls.Add(Me.GroupBox5)
      Me.GroupBox1.Controls.Add(Me.btnApply)
      Me.GroupBox1.Location = New System.Drawing.Point(16, 456)
      Me.GroupBox1.Name = "GroupBox1"
      Me.GroupBox1.Size = New System.Drawing.Size(200, 216)
      Me.GroupBox1.TabIndex = 44
      Me.GroupBox1.TabStop = False
      '
      'GroupBox3
      '
      Me.GroupBox3.Controls.Add(Me.nudDOMBookLimit)
      Me.GroupBox3.Location = New System.Drawing.Point(8, 112)
      Me.GroupBox3.Name = "GroupBox3"
      Me.GroupBox3.Size = New System.Drawing.Size(184, 48)
      Me.GroupBox3.TabIndex = 45
      Me.GroupBox3.TabStop = False
      Me.GroupBox3.Text = "DOMBookLimit"
      '
      'nudDOMBookLimit
      '
      Me.nudDOMBookLimit.Location = New System.Drawing.Point(8, 16)
      Me.nudDOMBookLimit.Maximum = New Decimal(New Integer() {10000, 0, 0, 0})
      Me.nudDOMBookLimit.Name = "nudDOMBookLimit"
      Me.nudDOMBookLimit.Size = New System.Drawing.Size(168, 22)
      Me.nudDOMBookLimit.TabIndex = 0
      '
      'GroupBox6
      '
      Me.GroupBox6.Controls.Add(Me.cmbBBAType)
      Me.GroupBox6.Location = New System.Drawing.Point(8, 64)
      Me.GroupBox6.Name = "GroupBox6"
      Me.GroupBox6.Size = New System.Drawing.Size(184, 48)
      Me.GroupBox6.TabIndex = 44
      Me.GroupBox6.TabStop = False
      Me.GroupBox6.Text = "BBAType"
      '
      'cmbBBAType
      '
      Me.cmbBBAType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
      Me.cmbBBAType.Location = New System.Drawing.Point(8, 16)
      Me.cmbBBAType.Name = "cmbBBAType"
      Me.cmbBBAType.Size = New System.Drawing.Size(168, 24)
      Me.cmbBBAType.TabIndex = 43
      '
      'GroupBox5
      '
      Me.GroupBox5.Controls.Add(Me.cmbDataSubscriptionLevel)
      Me.GroupBox5.Location = New System.Drawing.Point(8, 16)
      Me.GroupBox5.Name = "GroupBox5"
      Me.GroupBox5.Size = New System.Drawing.Size(184, 48)
      Me.GroupBox5.TabIndex = 43
      Me.GroupBox5.TabStop = False
      Me.GroupBox5.Text = "DataSubscriptionLevel"
      '
      'cmbDataSubscriptionLevel
      '
      Me.cmbDataSubscriptionLevel.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
      Me.cmbDataSubscriptionLevel.Location = New System.Drawing.Point(8, 16)
      Me.cmbDataSubscriptionLevel.Name = "cmbDataSubscriptionLevel"
      Me.cmbDataSubscriptionLevel.Size = New System.Drawing.Size(168, 24)
      Me.cmbDataSubscriptionLevel.TabIndex = 43
      '
      'btnApply
      '
      Me.btnApply.BackColor = System.Drawing.SystemColors.Control
      Me.btnApply.Enabled = False
      Me.btnApply.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
      Me.btnApply.Location = New System.Drawing.Point(56, 168)
      Me.btnApply.Name = "btnApply"
      Me.btnApply.Size = New System.Drawing.Size(96, 32)
      Me.btnApply.TabIndex = 19
      Me.btnApply.Text = "Apply"
      '
      'txtSymbol
      '
      Me.txtSymbol.Enabled = False
      Me.txtSymbol.Location = New System.Drawing.Point(80, 24)
      Me.txtSymbol.Name = "txtSymbol"
      Me.txtSymbol.Size = New System.Drawing.Size(136, 22)
      Me.txtSymbol.TabIndex = 42
      Me.txtSymbol.Text = ""
      '
      'Label4
      '
      Me.Label4.BackColor = System.Drawing.SystemColors.Control
      Me.Label4.Font = New System.Drawing.Font("Arial", 10.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.Label4.ForeColor = System.Drawing.SystemColors.ControlText
      Me.Label4.Location = New System.Drawing.Point(16, 24)
      Me.Label4.Name = "Label4"
      Me.Label4.Size = New System.Drawing.Size(64, 21)
      Me.Label4.TabIndex = 43
      Me.Label4.Text = "Symbol :"
      Me.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
      '
      'btnSubscribe
      '
      Me.btnSubscribe.BackColor = System.Drawing.SystemColors.Control
      Me.btnSubscribe.Enabled = False
      Me.btnSubscribe.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
      Me.btnSubscribe.Location = New System.Drawing.Point(32, 56)
      Me.btnSubscribe.Name = "btnSubscribe"
      Me.btnSubscribe.Size = New System.Drawing.Size(168, 25)
      Me.btnSubscribe.TabIndex = 41
      Me.btnSubscribe.Text = "Subscribe"
      '
      'btnRemoveAll
      '
      Me.btnRemoveAll.BackColor = System.Drawing.SystemColors.Control
      Me.btnRemoveAll.Enabled = False
      Me.btnRemoveAll.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
      Me.btnRemoveAll.Location = New System.Drawing.Point(120, 688)
      Me.btnRemoveAll.Name = "btnRemoveAll"
      Me.btnRemoveAll.Size = New System.Drawing.Size(104, 25)
      Me.btnRemoveAll.TabIndex = 38
      Me.btnRemoveAll.Text = "Remove All"
      '
      'btnRemove
      '
      Me.btnRemove.BackColor = System.Drawing.SystemColors.Control
      Me.btnRemove.Enabled = False
      Me.btnRemove.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
      Me.btnRemove.Location = New System.Drawing.Point(8, 688)
      Me.btnRemove.Name = "btnRemove"
      Me.btnRemove.Size = New System.Drawing.Size(104, 25)
      Me.btnRemove.TabIndex = 37
      Me.btnRemove.Text = "Remove Selected"
      '
      'lstInstruments
      '
      Me.lstInstruments.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
      Me.lstInstruments.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.lstInstruments.ItemHeight = 16
      Me.lstInstruments.Location = New System.Drawing.Point(8, 88)
      Me.lstInstruments.Name = "lstInstruments"
      Me.lstInstruments.Size = New System.Drawing.Size(216, 354)
      Me.lstInstruments.TabIndex = 32
      '
      'gbProperties
      '
      Me.gbProperties.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.gbProperties.Location = New System.Drawing.Point(248, 48)
      Me.gbProperties.Name = "gbProperties"
      Me.gbProperties.Size = New System.Drawing.Size(448, 640)
      Me.gbProperties.TabIndex = 44
      Me.gbProperties.TabStop = False
      Me.gbProperties.Text = "Instrument Properties"
      '
      'gbQuotes
      '
      Me.gbQuotes.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.gbQuotes.Location = New System.Drawing.Point(704, 48)
      Me.gbQuotes.Name = "gbQuotes"
      Me.gbQuotes.Size = New System.Drawing.Size(368, 352)
      Me.gbQuotes.TabIndex = 45
      Me.gbQuotes.TabStop = False
      Me.gbQuotes.Text = "Quotes"
      '
      'gbDOM
      '
      Me.gbDOM.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.gbDOM.ForeColor = System.Drawing.SystemColors.ControlText
      Me.gbDOM.Location = New System.Drawing.Point(704, 400)
      Me.gbDOM.Name = "gbDOM"
      Me.gbDOM.Size = New System.Drawing.Size(368, 288)
      Me.gbDOM.TabIndex = 46
      Me.gbDOM.TabStop = False
      Me.gbDOM.Text = "Depth Of Market(DOM)"
      '
      'gbSessions
      '
      Me.gbSessions.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(204, Byte))
      Me.gbSessions.Location = New System.Drawing.Point(248, 688)
      Me.gbSessions.Name = "gbSessions"
      Me.gbSessions.Size = New System.Drawing.Size(824, 120)
      Me.gbSessions.TabIndex = 47
      Me.gbSessions.TabStop = False
      Me.gbSessions.Text = "Sessions"
      '
      'frmInstrumentProperties
      '
      Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
      Me.BackColor = System.Drawing.SystemColors.Control
      Me.ClientSize = New System.Drawing.Size(1074, 816)
      Me.Controls.Add(Me.gbSessions)
      Me.Controls.Add(Me.gbDOM)
      Me.Controls.Add(Me.gbQuotes)
      Me.Controls.Add(Me.gbProperties)
      Me.Controls.Add(Me.GroupBox2)
      Me.Controls.Add(Me.lblDataConnection)
      Me.Controls.Add(Me.PictureBox1)
      Me.Controls.Add(Me.llWeb)
      Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
      Me.MaximizeBox = False
      Me.Name = "frmInstrumentProperties"
      Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
      Me.Text = "Instrument Properties"
      Me.GroupBox2.ResumeLayout(False)
      Me.GroupBox1.ResumeLayout(False)
      Me.GroupBox3.ResumeLayout(False)
      CType(Me.nudDOMBookLimit, System.ComponentModel.ISupportInitialize).EndInit()
      Me.GroupBox6.ResumeLayout(False)
      Me.GroupBox5.ResumeLayout(False)
      Me.ResumeLayout(False)

   End Sub

#End Region

   ''' <summary>
   ''' Create an m_CEL object, change its configurations, start up and initialize HashTable and grids.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub frmInstrumentProperties_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      Try
         m_Status = True
         CEL_DataConnectionStatusChanged(eConnectionStatus.csConnectionDown)

         m_CEL = New CQGCEL
         m_CEL.APIConfiguration.CollectionsThrowException = False
         m_CEL.APIConfiguration.ReadyStatusCheck = eReadyStatusCheck.rscOff
         m_CEL.APIConfiguration.TimeZoneCode = eTimeZone.tzCentral
         m_CEL.APIConfiguration.SnapshotPeriod = 250
         m_CEL.Startup()

         InitPropertyFields()
         InitQuoteFields()
         InitDOMFields()
         InitSessionsFields()
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "frmInstrumentProperties_Load", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Simple function to implement post increment
   ''' </summary>
   Private Function PostIncr(ByRef value_ As Integer) As Integer
      PostIncr = value_
      value_ += 1
   End Function

   ''' <summary>
   ''' Initialize the properties hash table.
   ''' </summary>
   Private Sub InitPropertiesTable()
      m_PropTypeToData = New Hashtable

      Dim row As Integer = 0

      m_PropTypeToData.Add(eInstrumentProperty.ipFullName, New DataHolder(PostIncr(row), "FullName"))
      m_PropTypeToData.Add(eInstrumentProperty.ipDescription, New DataHolder(PostIncr(row), "Description"))
      m_PropTypeToData.Add(eInstrumentProperty.ipInstrumentID, New DataHolder(PostIncr(row), "InstrumentID"))
      m_PropTypeToData.Add(eInstrumentProperty.ipCurrency, New DataHolder(PostIncr(row), "Currency"))
      m_PropTypeToData.Add(eInstrumentProperty.ipExpirationDate, New DataHolder(PostIncr(row), "ExpirationDate"))
      m_PropTypeToData.Add(eInstrumentProperty.ipFirstNoticeDate, New DataHolder(PostIncr(row), "FirstNoticeDate"))
      m_PropTypeToData.Add(eInstrumentProperty.ipInitialMargin, New DataHolder(PostIncr(row), "InitialMargin"))
      m_PropTypeToData.Add(eInstrumentProperty.ipMaintenanceMargin, New DataHolder(PostIncr(row), "MaintenanceMargin"))
      m_PropTypeToData.Add(eInstrumentProperty.ipSessionMask, New DataHolder(PostIncr(row), "SessionMask"))
      m_PropTypeToData.Add(eInstrumentProperty.ipCommodity, New DataHolder(PostIncr(row), "Commodity"))
      m_PropTypeToData.Add(eInstrumentProperty.ipCountry, New DataHolder(PostIncr(row), "Country"))
      m_PropTypeToData.Add(eInstrumentProperty.ipMonthChar, New DataHolder(PostIncr(row), "MonthChar"))
      m_PropTypeToData.Add(eInstrumentProperty.ipMonth, New DataHolder(PostIncr(row), "Month"))
      m_PropTypeToData.Add(eInstrumentProperty.ipStrike, New DataHolder(PostIncr(row), "Strike"))
      m_PropTypeToData.Add(eInstrumentProperty.ipInstrumentType, New DataHolder(PostIncr(row), "InstrumentType"))
      m_PropTypeToData.Add(eInstrumentProperty.ipYear, New DataHolder(PostIncr(row), "Year"))
      m_PropTypeToData.Add(eInstrumentProperty.ipYearString, New DataHolder(PostIncr(row), "YearString"))
      m_PropTypeToData.Add(eInstrumentProperty.ipTickSize, New DataHolder(PostIncr(row), "TickSize"))
      m_PropTypeToData.Add(eInstrumentProperty.ipSessionNumber, New DataHolder(PostIncr(row), "SessionNumber"))
      m_PropTypeToData.Add(eInstrumentProperty.ipNetChange, New DataHolder(PostIncr(row), "NetChange"))
      m_PropTypeToData.Add(eInstrumentProperty.ipDTE, New DataHolder(PostIncr(row), "DTE"))
      m_PropTypeToData.Add(eInstrumentProperty.ipYCOI, New DataHolder(PostIncr(row), "YCOI"))
      m_PropTypeToData.Add(eInstrumentProperty.ipIsDownTick, New DataHolder(PostIncr(row), "IsDownTick"))
      m_PropTypeToData.Add(eInstrumentProperty.ipIsUpTick, New DataHolder(PostIncr(row), "IsUpTick"))
      m_PropTypeToData.Add(eInstrumentProperty.ipIsFastMarket, New DataHolder(PostIncr(row), "IsFastMarket"))
      m_PropTypeToData.Add(eInstrumentProperty.ipTodayCTotalVolume, New DataHolder(PostIncr(row), "TodayCTotalVolume"))
      m_PropTypeToData.Add(eInstrumentProperty.ipPreferredSessionName, New DataHolder(PostIncr(row), "PreferredSessionName"))
      m_PropTypeToData.Add(eInstrumentProperty.ipDelayTime, New DataHolder(PostIncr(row), "DelayTime"))
      m_PropTypeToData.Add(eInstrumentProperty.ipExchangeAbbreviation, New DataHolder(PostIncr(row), "ExchangeAbbreviation"))
      m_PropTypeToData.Add(eInstrumentProperty.ipLeadingContractName, New DataHolder(PostIncr(row), "LeadingContractName"))
      m_PropTypeToData.Add(eInstrumentProperty.ipYesterdayCTotalVolume, New DataHolder(PostIncr(row), "YesterdayCTotalVolume"))
      m_PropTypeToData.Add(eInstrumentProperty.ipWorkup, New DataHolder(PostIncr(row), "Workup"))
      m_PropTypeToData.Add(eInstrumentProperty.ipIsFutureStyleOption, New DataHolder(PostIncr(row), "Future Style Option"))
   End Sub

   ''' <summary>
   ''' Initialize the quotes hash table.
   ''' </summary>
   Private Sub InitQuotesTable()
      m_QuoteTypeToData = New Hashtable

      Dim row As Integer = 0

      m_QuoteTypeToData.Add(eQuoteType.qtAsk, New DataHolder(PostIncr(row), "Ask"))
      m_QuoteTypeToData.Add(eQuoteType.qtBid, New DataHolder(PostIncr(row), "Bid"))
      m_QuoteTypeToData.Add(eQuoteType.qtTrade, New DataHolder(PostIncr(row), "Trade"))
      m_QuoteTypeToData.Add(eQuoteType.qtCohUndAsk, New DataHolder(PostIncr(row), "CohUndAsk"))
      m_QuoteTypeToData.Add(eQuoteType.qtCohUndBid, New DataHolder(PostIncr(row), "CohUndBid"))
      m_QuoteTypeToData.Add(eQuoteType.qtImpliedAsk, New DataHolder(PostIncr(row), "ImpliedAsk"))
      m_QuoteTypeToData.Add(eQuoteType.qtImpliedBid, New DataHolder(PostIncr(row), "ImpliedBid"))
      m_QuoteTypeToData.Add(eQuoteType.qtOutrightAsk, New DataHolder(PostIncr(row), "OutrightAsk"))
      m_QuoteTypeToData.Add(eQuoteType.qtOutrightBid, New DataHolder(PostIncr(row), "OutrightBid"))
      m_QuoteTypeToData.Add(eQuoteType.qtDayOpen, New DataHolder(PostIncr(row), "DayOpen"))
      m_QuoteTypeToData.Add(eQuoteType.qtDayHigh, New DataHolder(PostIncr(row), "DayHigh"))
      m_QuoteTypeToData.Add(eQuoteType.qtDayLow, New DataHolder(PostIncr(row), "DayLow"))
      m_QuoteTypeToData.Add(eQuoteType.qtIndicativeOpen, New DataHolder(PostIncr(row), "IndicativeOpen"))
      m_QuoteTypeToData.Add(eQuoteType.qtSettlement, New DataHolder(PostIncr(row), "Settlement"))
      m_QuoteTypeToData.Add(eQuoteType.qtYesterdaySettlement, New DataHolder(PostIncr(row), "YesterdaySettlement"))
      m_QuoteTypeToData.Add(eQuoteType.qtMarker, New DataHolder(PostIncr(row), "Marker"))
      m_QuoteTypeToData.Add(eQuoteType.qtTodayMarker, New DataHolder(PostIncr(row), "TodayMarker"))
   End Sub

   ''' <summary>
   ''' Create and initialize the grid of properties.
   ''' </summary>
   Private Sub InitPropertyFields()
      InitPropertiesTable()

      m_PropertiesGrid = New CQGMiniGrid(2, m_PropTypeToData.Count, gbProperties)

      m_PropertiesGrid.ColumnWidth(0) = 152
      m_PropertiesGrid.ColumnWidth(1) = 282

      m_PropertiesGrid.HeaderValue(0) = "Property Name"
      m_PropertiesGrid.HeaderValue(1) = "Value"

      Dim propHld As DataHolder
      For Each item As DictionaryEntry In m_PropTypeToData
         propHld = CType(item.Value, DataHolder)
         m_PropertiesGrid.Item(propHld.Row, 0).Text = propHld.Name
      Next
   End Sub

   ''' <summary>
   ''' Create and initialize the grid of quotes.
   ''' </summary>
   Private Sub InitQuoteFields()
      InitQuotesTable()

      m_QuotesGrid = New CQGMiniGrid(4, 17, gbQuotes)

      m_QuotesGrid.ColumnWidth(0) = 135
      m_QuotesGrid.HeaderValue(0) = "Quote Name"
      m_QuotesGrid.ColumnWidth(1) = 70
      m_QuotesGrid.HeaderValue(1) = "Price"
      m_QuotesGrid.ColumnWidth(2) = 63
      m_QuotesGrid.HeaderValue(2) = "Volume"
      m_QuotesGrid.ColumnWidth(3) = 90
      m_QuotesGrid.HeaderValue(3) = "Display Price"

      Dim quoteHld As DataHolder
      For Each item As DictionaryEntry In m_QuoteTypeToData
         quoteHld = CType(item.Value, DataHolder)
         m_QuotesGrid.Item(quoteHld.Row, 0).Text = quoteHld.Name
      Next
   End Sub

   ''' <summary>
   ''' Create and initialize the grid of DOM.
   ''' </summary>
   Private Sub InitDOMFields()
      m_DOMGrid = New CQGMiniGrid(3, 12, gbDOM)

      m_DOMGrid.ColumnWidth(0) = 119
      m_DOMGrid.ColumnAlign(0) = ContentAlignment.MiddleRight
      m_DOMGrid.HeaderValue(0) = "Ask Volume"
      m_DOMGrid.ColumnWidth(1) = 115
      m_DOMGrid.ColumnAlign(1) = ContentAlignment.MiddleCenter
      m_DOMGrid.HeaderValue(1) = "Price"
      m_DOMGrid.ColumnWidth(2) = 120
      m_DOMGrid.ColumnAlign(2) = ContentAlignment.MiddleLeft
      m_DOMGrid.HeaderValue(2) = "Bid Volume"
   End Sub

   ''' <summary>
   ''' Create and initialize the grid of sessions.
   ''' </summary>
   Private Sub InitSessionsFields()
      m_SessionsGrid = New CQGMiniGrid(8, 4, gbSessions)

      m_SessionsGrid.ColumnWidth(0) = 170
      m_SessionsGrid.HeaderValue(0) = "Name"

      m_SessionsGrid.ColumnWidth(1) = 57
      m_SessionsGrid.ColumnAlign(1) = ContentAlignment.MiddleCenter
      m_SessionsGrid.HeaderValue(1) = "Number"

      m_SessionsGrid.ColumnWidth(2) = 156
      m_SessionsGrid.ColumnAlign(2) = ContentAlignment.MiddleCenter
      m_SessionsGrid.HeaderValue(2) = "Activation Date"

      m_SessionsGrid.ColumnWidth(3) = 69
      m_SessionsGrid.ColumnAlign(3) = ContentAlignment.MiddleCenter
      m_SessionsGrid.HeaderValue(3) = "Start Time"

      m_SessionsGrid.ColumnWidth(4) = 69
      m_SessionsGrid.ColumnAlign(4) = ContentAlignment.MiddleCenter
      m_SessionsGrid.HeaderValue(4) = "End Time"

      m_SessionsGrid.ColumnWidth(5) = 72
      m_SessionsGrid.ColumnAlign(5) = ContentAlignment.MiddleCenter
      m_SessionsGrid.HeaderValue(5) = "Is Primary"

      m_SessionsGrid.ColumnWidth(6) = 82
      m_SessionsGrid.ColumnAlign(6) = ContentAlignment.MiddleCenter
      m_SessionsGrid.HeaderValue(6) = "Type"

      m_SessionsGrid.ColumnWidth(7) = 125
      m_SessionsGrid.ColumnAlign(7) = ContentAlignment.MiddleCenter
      m_SessionsGrid.HeaderValue(7) = "Working Week Days"
   End Sub

   ''' <summary>
   ''' Shut down m_CEL.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' A CancelEventArgs that contains the event data.
   ''' </param>
   Private Sub frmInstrumentProperties_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
      Try
         m_CEL.Shutdown()
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "frmInstrumentProperties_Closing", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired, when some changes occur in the connection with the CQG data server.
   ''' </summary>
   ''' <param name="newStatus">
   ''' The current status of the connection with the data server.
   ''' </param>
   Private Sub CEL_DataConnectionStatusChanged(ByVal newStatus As eConnectionStatus) Handles m_CEL.DataConnectionStatusChanged
      Try
         Dim info As String
         Dim BackCol As System.Drawing.Color

         If newStatus <> eConnectionStatus.csConnectionUp Then
            BackCol = System.Drawing.Color.FromArgb(255, 114, 0)
            info = "DATA Connection is " & IIf(newStatus = eConnectionStatus.csConnectionDelayed, _
                                                "Delayed", "Down").ToString()

            txtSymbol.Text = vbNullString
            txtSymbol.Enabled = False
            btnSubscribe.Enabled = False
         Else
            BackCol = System.Drawing.Color.FromArgb(192, 209, 205)
            info = "DATA Connection is UP"

            txtSymbol.Enabled = m_Status
            btnSubscribe.Enabled = False
         End If

         lblDataConnection.BackColor = BackCol
         lblDataConnection.Text = info
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "CEL_DataConnectionStatusChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired when a new instrument is resolved and subscribed.
   ''' </summary>
   ''' <param name="symbl">
   ''' The commodity symbol that was requested by the user in the NewInstrument method. 
   ''' </param>
   ''' <param name="Instrument">
   ''' The resolved CQGInstrument object.
   ''' </param>
    Private Sub CEL_InstrumentResolved(ByVal symbl As String, ByVal instrument As CQGInstrument, ByVal cqgError As CQGError) Handles m_CEL.InstrumentResolved
        Try
            If m_CEL.IsValid(cqgError) Then
                MessageBox.Show("Incorrect symbol: " & symbl.ToUpper() & ". Description: " & cqgError.Description,
                                "InstrumentProperties", MessageBoxButtons.OK, MessageBoxIcon.Warning)
                txtSymbol.Clear()
                m_Status = True
                txtSymbol.Enabled = (m_CEL.Environment.DataConnectionStatus = eConnectionStatus.csConnectionUp)
                btnSubscribe.Enabled = False
                txtSymbol.Focus()
                Return
            End If
            Dim index As Integer = lstInstruments.Items.IndexOf(instrument.FullName)
            If index = -1 Then
                lstInstruments.Items.Add(instrument.FullName)
                lstInstruments.SelectedIndex = lstInstruments.Items.Count - 1
            Else
                lstInstruments.SelectedIndex = index
            End If

            m_Status = True
            btnSubscribe.Enabled = (m_CEL.Environment.DataConnectionStatus = eConnectionStatus.csConnectionUp)
            txtSymbol.Enabled = (m_CEL.Environment.DataConnectionStatus = eConnectionStatus.csConnectionUp)
            txtSymbol.Text = vbNullString
        Catch ex As Exception
            HandleError("frmInstrumentProperties", "CEL_InstrumentResolved", ex)
        End Try
    End Sub

   ''' <summary>
   ''' This event is fired when any of the instrument quotes or dynamic instrument properties are changed.
   ''' </summary>
   ''' <param name="Instrument">
   ''' The changed instrument. 
   ''' </param>
   ''' <param name="Quotes">
   ''' The collection of changed quotes.
   ''' </param>
   ''' <param name="props">
   ''' The collection of changed dynamic properties. 
   ''' </param>
   Private Sub CEL_InstrumentChanged(ByVal instrument As CQGInstrument, _
                                     ByVal quotes As CQGQuotes, _
                                     ByVal props As CQGInstrumentProperties) Handles m_CEL.InstrumentChanged
      Try
         If instrument.FullName = m_InstrumentFullName Then
            DisplayProperties(props)
            DisplayQuotes(quotes)
            DisplaySessions(instrument.Sessions)
         End If
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "CEL_InstrumentChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired when instrument's DOM is updated.
   ''' </summary>
   ''' <param name="Instrument">
   ''' Changed instrument: its DOMAsks and DOMBids collections contain new DOM book.
   ''' </param>
   ''' <param name="prevAsks">
   ''' The collection of asks from the previous DOM book.
   ''' </param>
   ''' <param name="prevBids">
   ''' The collection of bids from the previous DOM book.
   ''' </param>
   Private Sub CEL_InstrumentDOMChanged(ByVal instrument As CQGInstrument, _
                                        ByVal prevAsks As CQGDOMQuotes, _
                                        ByVal prevBids As CQGDOMQuotes) Handles m_CEL.InstrumentDOMChanged
      Try
         If instrument.FullName = m_InstrumentFullName Then
            DisplayDOM(instrument)
         End If
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "CEL_InstrumentDOMChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired, when CQGCEL detects some abnormal discrepancy between data expected and data received.
   ''' </summary>
   ''' <param name="obj">
   ''' Object, in which the error occurred.
   ''' </param>
   ''' <param name="errorDescription">
   ''' String, describing the error.
   ''' </param>
   Private Sub CEL_DataError(ByVal obj As Object, ByVal errorDescription As String) Handles m_CEL.DataError
      Try
         Dim cqgErr As CQGError = TryCast(obj, CQGError)
         If m_CEL.IsValid(cqgErr) Then
            If cqgErr.Code = 102 Then
               errorDescription &= " Restart the application."
            ElseIf cqgErr.Code = 125 Then
               errorDescription &= " Turn on CQG Client and restart the application."
            End If
         End If

         MessageBox.Show(errorDescription, "InstrumentProperties", MessageBoxButtons.OK, MessageBoxIcon.Information)
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "CEL_DataError", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Subscribe to a new instrument
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub btnSubscribe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSubscribe.Click
      Try
         If Len(txtSymbol.Text) > 0 Then
            m_CEL.NewInstrument(Trim(txtSymbol.Text))
         End If
         m_Status = False
         btnSubscribe.Enabled = False
         txtSymbol.Enabled = False
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "btnSubscribe_Click", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Enable/disable the "Subscribe" button's status, if the Symbol's textbox is full/empty.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub txtSymbol_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSymbol.TextChanged
      btnSubscribe.Enabled = Len(Trim(txtSymbol.Text)) > 0
   End Sub

   ''' <summary>
   ''' When the "Enter" button is clicked, call btnSubscribe_Click sub, which subscribes to a new instrument.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' A KeyEventArgs that contains the event data.
   ''' </param>
   Private Sub txtSymbol_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtSymbol.KeyDown
      If e.KeyCode = Keys.Enter Then
         btnSubscribe_Click(sender, e)
      End If
   End Sub

   ''' <summary>
   ''' Open CQG API web page.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' A LinkLabelLinkClickedEventArgs that contains the event data.
   ''' </param>
   Private Sub llWeb_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles llWeb.LinkClicked
      Try
         System.Diagnostics.Process.Start("iexplore.exe", "http://www.cqg.com/Products/CQG-API.aspx")
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "llWeb_LinkClicked", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Remove the selected instrument.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub btnRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemove.Click
      Try
         m_CEL.RemoveInstrument(m_CEL.Instruments(m_InstrumentFullName))
         lstInstruments.Items.RemoveAt(lstInstruments.SelectedIndex)
         If lstInstruments.Items.Count > 0 Then
            If lstInstruments.SelectedIndex = -1 Then
               lstInstruments.SelectedIndex = 0
            End If
         Else
            OnInstrumentsListBoxChange()
         End If
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "btnRemove_Click", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Remove all instrument.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub btnRemoveAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemoveAll.Click
      Try
         m_CEL.RemoveAllInstruments()
         lstInstruments.Items.Clear()
         OnInstrumentsListBoxChange()
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "btnRemoveAll_Click", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Applies new DataSubscriptionLevel and/or BBAType.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub btnApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnApply.Click
      Try
         Dim instrument As CQGInstrument = m_CEL.Instruments(m_InstrumentFullName)

         If cmbDataSubscriptionLevel.Text = "dsNone" Then
            instrument.DataSubscriptionLevel = eDataSubscriptionLevel.dsNone
         ElseIf cmbDataSubscriptionLevel.Text = "dsQuotes" Then
            instrument.DataSubscriptionLevel = eDataSubscriptionLevel.dsQuotes
         ElseIf cmbDataSubscriptionLevel.Text = "dsQuotesAndBBA" Then
            instrument.DataSubscriptionLevel = eDataSubscriptionLevel.dsQuotesAndBBA
         ElseIf cmbDataSubscriptionLevel.Text = "dsQuotesAndDOM" Then
            instrument.DataSubscriptionLevel = eDataSubscriptionLevel.dsQuotesAndDOM
         End If

         If cmbBBAType.Text = "dbtCombined" Then
            instrument.BBAType = eDOMandBBAType.dbtCombined
         ElseIf cmbBBAType.Text = "dbtImplied" Then
            instrument.BBAType = eDOMandBBAType.dbtImplied
         ElseIf cmbBBAType.Text = "dbtOutright" Then
            instrument.BBAType = eDOMandBBAType.dbtOutright
         End If

         instrument.DOMBookLimit = Decimal.ToInt32(nudDOMBookLimit.Value)

         btnApply.Enabled = False
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "btnApply_Click", ex)
      End Try
   End Sub

   ''' <summary>
   ''' This event is fired when new DataSubscriptionLevel is selected
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data
   ''' </param>
   Private Sub cmbDataSubscriptionLevel_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbDataSubscriptionLevel.SelectedIndexChanged
      OnDataSubscriptionLevelOrBBATypeChange()
   End Sub

   ''' <summary>
   ''' This event is fired when a new BBAType is selected.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub cmbBBAType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbBBAType.SelectedIndexChanged
      OnDataSubscriptionLevelOrBBATypeChange()
   End Sub

   ''' <summary>
   ''' This event is fired when a new Instrument is selected in the Instruments listbox.
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param>
   ''' <param name="e">
   ''' An EventArgs that contains the event data.
   ''' </param>
   Private Sub lstInstruments_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstInstruments.SelectedIndexChanged
      Try
         OnInstrumentsListBoxChange()
         DataSubscriptionLevelAndBBATypeComboInit()
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "lstInstruments_SelectedIndexChanged", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Initialize new DataSubscriptionLevel and BBAType combo boxes.
   ''' </summary>
   Private Sub DataSubscriptionLevelAndBBATypeComboInit()
      If lstInstruments.SelectedIndex > -1 Then
         If cmbDataSubscriptionLevel.Items.Count = 0 Then
            cmbDataSubscriptionLevel.Items.Add("dsNone")
            cmbDataSubscriptionLevel.Items.Add("dsQuotes")
            cmbDataSubscriptionLevel.Items.Add("dsQuotesAndBBA")
            cmbDataSubscriptionLevel.Items.Add("dsQuotesAndDOM")
         End If

         If cmbBBAType.Items.Count = 0 Then
            cmbBBAType.Items.Add("dbtCombined")
            cmbBBAType.Items.Add("dbtImplied")
            cmbBBAType.Items.Add("dbtOutright")
         End If

         Dim instrument As CQGInstrument = m_CEL.Instruments(m_InstrumentFullName)
         cmbDataSubscriptionLevel.Text = instrument.DataSubscriptionLevel.ToString()
         cmbBBAType.Text = instrument.BBAType.ToString()
         nudDOMBookLimit.Value = instrument.DOMBookLimit
      End If
   End Sub

   ''' <summary>
   ''' Enable the "Apply" button, if new DataSubscriptionLevel and/or BBAType is selected.
   ''' </summary>
   Private Sub OnDataSubscriptionLevelOrBBATypeChange()
      Try
         If cmbDataSubscriptionLevel.Items.Count > 0 And cmbBBAType.Items.Count > 0 Then
            Dim instrument As CQGInstrument = m_CEL.Instruments(m_InstrumentFullName)
            btnApply.Enabled = (cmbDataSubscriptionLevel.Text <> instrument.DataSubscriptionLevel.ToString()) _
                                 Or (cmbBBAType.Text <> instrument.BBAType.ToString()) _
                                    Or (nudDOMBookLimit.Value <> instrument.DOMBookLimit)
         Else
            btnApply.Enabled = False
         End If
      Catch ex As Exception
         HandleError("frmInstrumentProperties", "OnDataSubscriptionLevelOrBBATypeChange", ex)
      End Try
   End Sub

   ''' <summary>
   ''' Clear the grid, if an instrument is not selected, otherwise fill/update params for the selected instrument.
   ''' </summary>
   ''' <param name="props">
   ''' The collection of params, which were changed.
   ''' </param>
   Private Sub DisplayProperties(ByVal props As CQGInstrumentProperties)
      If props Is Nothing Then
         m_PropertiesGrid.ClearColumn(1)
         Return
      End If


      Dim dispVal As String
      Dim propHld As DataHolder
      For Each item As DictionaryEntry In m_PropTypeToData
         Try

            Dim prop As CQGInstrumentProperty = props(DirectCast(item.Key, eInstrumentProperty))

            If Not prop Is Nothing Then
               dispVal = N_A
               If m_CEL.IsValid(prop.Value) Then
                  If prop.Type = eInstrumentProperty.ipInstrumentType Then
                     dispVal = DirectCast(prop.Value, eInstrumentType).ToString()
                  Else
                     dispVal = prop.Value.ToString()
                  End If
               End If

               propHld = DirectCast(item.Value, DataHolder)
               m_PropertiesGrid.Item(propHld.Row, 1).Text = dispVal
            End If
         Catch ex As Exception
            Dim msg As String = "ERROR: " & ex.Message
            If DirectCast(item.Key, eInstrumentProperty) = eInstrumentProperty.ipTickSize Then
               msg = "Variable tick size"
            ElseIf DirectCast(item.Key, eInstrumentProperty) = eInstrumentProperty.ipTickValue Then
               msg = "Variable tick value"
            End If

            propHld = DirectCast(item.Value, DataHolder)
            m_PropertiesGrid.Item(propHld.Row, 1).Text = msg
         End Try
      Next

   End Sub

   ''' <summary>
   ''' Clear the grid, if an instrument is not selected, otherwise fill/update quotes for selected instrument.
   ''' </summary>
   ''' <param name="Quotes">
   ''' The collection of quotes, which were changed.
   ''' </param>
   Private Sub DisplayQuotes(ByVal quotes As CQGQuotes)
      If quotes Is Nothing Then
         m_QuotesGrid.ClearColumn(1)
         m_QuotesGrid.ClearColumn(2)
         m_QuotesGrid.ClearColumn(3)
         Return
      End If

      Dim instrument As CQGInstrument = m_CEL.Instruments(m_InstrumentFullName)
      Dim dispPrice As String
      Dim dispVol As String
      Dim dispDisplayPrice As String

      Dim item As DictionaryEntry
      For Each item In m_QuoteTypeToData
         Dim quote As CQGQuote = quotes(DirectCast(item.Key, eQuoteType))

         If quote IsNot Nothing Then
            If quote.IsValid Then
               dispPrice = quote.Price.ToString()
               dispVol = CStr(IIf(quote.HasVolume, quote.VolumeFractional.ToString(), N_A))
               dispDisplayPrice = instrument.ToDisplayPrice(quote.Price)
            Else
               dispPrice = N_A
               dispVol = N_A
               dispDisplayPrice = N_A
            End If

            Dim quoteHld As DataHolder = DirectCast(item.Value, DataHolder)
            m_QuotesGrid.Item(quoteHld.Row, 1).Text = dispPrice
            m_QuotesGrid.Item(quoteHld.Row, 2).Text = dispVol
            m_QuotesGrid.Item(quoteHld.Row, 3).Text = dispDisplayPrice
         End If
      Next
   End Sub

   ''' <summary>
   ''' Display information about sessions.
   ''' </summary>
   Private Sub DisplaySessions(ByVal sessions As CQGSessions)
      m_SessionsGrid.Clear()
      If sessions Is Nothing Then
         Return
      End If
      Dim i As Integer = -1
      For Each session As CQGSession In sessions
         i += 1
         If i <= m_SessionsGrid.Rows Then
            m_SessionsGrid.Item(i, 0).Text = session.Name
            m_SessionsGrid.Item(i, 1).Text = session.Number.ToString()
            If m_CEL.IsValid(session.ActivationDate) Then
               m_SessionsGrid.Item(i, 2).Text = session.ActivationDate.ToString()
            Else
               m_SessionsGrid.Item(i, 2).Text = N_A
            End If
            If m_CEL.IsValid(session.StartTime) Then
               m_SessionsGrid.Item(i, 3).Text = session.StartTime.ToShortTimeString()
            Else
               m_SessionsGrid.Item(i, 3).Text = N_A
            End If
            If m_CEL.IsValid(session.EndTime) Then
               m_SessionsGrid.Item(i, 4).Text = session.EndTime.ToShortTimeString()
            Else
               m_SessionsGrid.Item(i, 4).Text = N_A
            End If
            m_SessionsGrid.Item(i, 5).Text = IIf(session.PrimaryFlag, "Yes", "No").ToString()
            m_SessionsGrid.Item(i, 6).Text = session.Type.ToString()
            m_SessionsGrid.Item(i, 7).Text = GetSessionWorkingDays(session.WorkingWeekDays)
         End If
      Next
   End Sub

   ''' <summary>
   ''' Clear the grid, if an instrument is not selected, otherwise fill/update DOMs for the selected instrument.
   ''' </summary>
   ''' <param name="Instrument">
   ''' The instrument for which DOM was updated.
   ''' </param>
   Private Sub DisplayDOM(ByVal instrument As CQGInstrument)
      If instrument Is Nothing Then
         m_DOMGrid.Clear()
         Return
      End If
      Dim r As Integer = CType(m_DOMGrid.Rows / 2, Integer)

      Dim dispPrice As String
      Dim dispVol As String
      Dim qt As CQGQuote

      For i As Integer = 0 To r - 1
         If i < instrument.DOMAsks.Count Then
            qt = instrument.DOMAsks(i)
            If (qt.IsValid) Then
               dispPrice = instrument.ToDisplayPrice(qt.Price)
               dispVol = qt.Volume.ToString
            Else
               dispPrice = N_A
               dispVol = N_A
            End If
         Else
            dispPrice = vbNullString
            dispVol = vbNullString
         End If

         m_DOMGrid.Item(r - 1 - i, 0).Text = dispVol
         m_DOMGrid.Item(r - 1 - i, 0).ForeColor = Color.Red
         m_DOMGrid.Item(r - 1 - i, 1).Text = dispPrice
      Next

      For i As Integer = r To m_DOMGrid.Rows - 1
         If i - m_DOMGrid.Rows / 2 < instrument.DOMBids.Count Then
            qt = instrument.DOMBids(i - r)
            If (qt.IsValid) Then
               dispPrice = instrument.ToDisplayPrice(qt.Price)
               dispVol = qt.Volume.ToString
            Else
               dispPrice = N_A
               dispVol = N_A
            End If
         Else
            dispPrice = vbNullString
            dispVol = vbNullString
         End If

         m_DOMGrid.Item(i, 1).Text = dispPrice
         m_DOMGrid.Item(i, 2).Text = dispVol
         m_DOMGrid.Item(i, 2).ForeColor = Color.Green
      Next
   End Sub

   ''' <summary>
   ''' This sub is called, if there was any change connected with the instruments (Add/Remove/Remove All/Selection Change).
   ''' </summary>
   Private Sub OnInstrumentsListBoxChange()
      If lstInstruments.Items.Count = 0 Then
         btnRemoveAll.Enabled = False
         cmbDataSubscriptionLevel.Items.Clear()
         cmbBBAType.Items.Clear()
         OnDataSubscriptionLevelOrBBATypeChange()
      Else
         btnRemoveAll.Enabled = True
      End If

      ClearAll()

      If lstInstruments.SelectedIndex > -1 Then
         btnRemove.Enabled = True
         m_InstrumentFullName = lstInstruments.Items(lstInstruments.SelectedIndex).ToString()

         Dim instrument As CQGInstrument = m_CEL.Instruments(m_InstrumentFullName)
         DisplayProperties(instrument.Properties)
         DisplayQuotes(instrument.Quotes)
         DisplayDOM(instrument)
         DisplaySessions(instrument.Sessions)
      End If
   End Sub

   ''' <summary>
   ''' Return the session's week working days in this format: "SMTWTFS".
   ''' </summary>
   ''' <param name="weekDay">
   ''' eSessionWeekDays bitmask, which contains information about working days.
   ''' </param>
   ''' <returns>
   ''' String, which contains working days.
   ''' </returns>
   Private Shared Function GetSessionWorkingDays(ByVal weekDay As eSessionWeekDays) As String
      Dim sResult As String

      sResult = IIf((weekDay And eSessionWeekDays.swdSunday) = eSessionWeekDays.swdSunday, "S", "-").ToString()
      sResult &= IIf((weekDay And eSessionWeekDays.swdMonday) = eSessionWeekDays.swdMonday, "M", "-").ToString()
      sResult &= IIf((weekDay And eSessionWeekDays.swdTuesday) = eSessionWeekDays.swdTuesday, "T", "-").ToString()
      sResult &= IIf((weekDay And eSessionWeekDays.swdWednesday) = eSessionWeekDays.swdWednesday, "W", "-").ToString()
      sResult &= IIf((weekDay And eSessionWeekDays.swdThursday) = eSessionWeekDays.swdThursday, "T", "-").ToString()
      sResult &= IIf((weekDay And eSessionWeekDays.swdFriday) = eSessionWeekDays.swdFriday, "F", "-").ToString()
      sResult &= IIf((weekDay And eSessionWeekDays.swdSaturday) = eSessionWeekDays.swdSaturday, "S", "-").ToString()

      Return sResult
   End Function

   ''' <summary>
   ''' This event is fired when DOM book limit is changed
   ''' </summary>
   ''' <param name="sender">
   ''' The source of the event.
   ''' </param> 
   ''' <param name="e">
   ''' An EventArgs that contains the event data
   ''' </param>
   Private Sub nudDOMBookLimit_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudDOMBookLimit.ValueChanged
      OnDataSubscriptionLevelOrBBATypeChange()
   End Sub

   ''' <summary>
   ''' Clears all data
   ''' </summary>
   Private Sub ClearAll()
      btnRemove.Enabled = False

      m_InstrumentFullName = vbNullString
      DisplayProperties(Nothing)
      DisplayQuotes(Nothing)
      DisplayDOM(Nothing)
      DisplaySessions(Nothing)
   End Sub
End Class
