// OrderPlacingMetaInfo.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "OrderPlacingMetaInfo.h"
#include "OrderPlacingMetaInfoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


class CTEMPORALModule : public ATL::CComModule
{
};

namespace
{
   // This instance is auxiliary. It will initialize all COM required
   // modules in its constructor.
   CTEMPORALModule atlTemp;
}

// COrderPlacingMetaInfoApp
BEGIN_MESSAGE_MAP(COrderPlacingMetaInfoApp, CWinApp)
   ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// COrderPlacingMetaInfoApp construction
COrderPlacingMetaInfoApp::COrderPlacingMetaInfoApp()
{
   // support Restart Manager
   m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;
}

// The one and only COrderPlacingMetaInfoApp object
COrderPlacingMetaInfoApp theApp;

// COrderPlacinMetaInfogApp initialization
BOOL COrderPlacingMetaInfoApp::InitInstance()
{
   // InitCommonControls() is required on Windows XP if an application
   // manifest specifies use of ComCtl32.dll version 6 or later to enable
   // visual styles.  Otherwise, any window creation will fail.
   InitCommonControls();

   // Initializes the COM library
   CoInitializeEx(nullptr, COINIT_APARTMENTTHREADED);

   CWinApp::InitInstance();

   COrderPlacingMetaInfoDlg dlg;
   m_pMainWnd = &dlg;
   dlg.DoModal();

   // Since the dialog has been closed, return FALSE so that we exit the
   // application, rather than start the application's message pump.
   return FALSE;
}

BOOL COrderPlacingMetaInfoApp::ExitInstance()
{
   // Close the COM library and unload all DLLs
   CoUninitialize();

   return CWinApp::ExitInstance();
}
