// GWLogonDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OrderProperties.h"
#include "GWLogonDlg.h"
#include <string>

// CGWLogonDlg dialog
CGWLogonDlg::CGWLogonDlg(CWnd* pParent /*=NULL*/, bool otpRequired /*=false*/) 
   : CDialog(CGWLogonDlg::IDD, pParent),
     m_otpRequired(otpRequired)
{
}

void CGWLogonDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Text(pDX, IDC_ED_USERNAME, m_Username);
   DDX_Text(pDX, IDC_ED_PASSWORD, m_Password);
   DDX_Text(pDX, IDC_ED_OTPASSWORD, m_OTPassword);
   DDX_Control(pDX, IDC_ED_OTPASSWORD, m_edOTPassword);
   DDX_Control(pDX, IDC_LBL_OTP, m_lblOTP);
   DDX_Control(pDX, IDC_LBL_LOGON_INFO, m_lblInfo);

   if (!m_otpRequired)
   {
      m_edOTPassword.ShowWindow(SW_HIDE);
      m_lblOTP.ShowWindow(SW_HIDE);
   }
   CString info = _T("Please specify username");
   info += m_otpRequired ? _T(", OTpassword ") : _T(" ");
   info += _T("and password to log on to Gateway. Note, that in DEMO trading mode the username and password are disregarded.");
   m_lblInfo.SetWindowText(info);
}

BEGIN_MESSAGE_MAP(CGWLogonDlg, CDialog)
END_MESSAGE_MAP()
